/* File: racial.c */

/*
 * Copyright (c) 1997 Ben Harrison, James E. Wilson, Robert A. Koeneke
 *
 * This software may be copied and distributed for educational, research,
 * and not for profit purposes provided that this copyright and statement
 * are included in all such copies.  Other copyrights may also apply.
 */

/* Purpose: Racial powers (and mutations) */

#include "angband.h"

/*
 * Hook to determine if an object is contertible in an arrow/bolt
 */
/*:::ʐ̂߂hook*/
///del131221 
#if 0
static bool item_tester_hook_convertible(object_type *o_ptr)
{
	if((o_ptr->tval==TV_JUNK) || (o_ptr->tval==TV_SKELETON)) return TRUE;

	if ((o_ptr->tval == TV_CORPSE) && (o_ptr->sval == SV_SKELETON)) return TRUE;
	/* Assume not */
	return (FALSE);
}
#endif

/*
 * do_cmd_cast calls this function if the player's class
 * is 'archer'.
 */
/*:::A[`[̖ʐ*/
///sysdel class A[`[ʐ

#if 0
static bool do_cmd_archer(void)
{
	int ext=0;
	char ch;

	object_type	forge;
	object_type     *q_ptr;

	char com[80];
	char o_name[MAX_NLEN];

	q_ptr = &forge;

	if(p_ptr->lev >= 20)
#ifdef JP
		sprintf(com, "[S]e, [A], [B]NX{E̖ :");
#else
		sprintf(com, "Create [S]hots, Create [A]rrow or Create [B]olt ?");
#endif
	else if(p_ptr->lev >= 10)
#ifdef JP
		sprintf(com, "[S]e, [A]:");
#else
		sprintf(com, "Create [S]hots or Create [A]rrow ?");
#endif
	else
#ifdef JP
		sprintf(com, "[S]e:");
#else
		sprintf(com, "Create [S]hots ?");
#endif

	if (p_ptr->confused)
	{
#ifdef JP
		msg_print("ĂI");
#else
		msg_print("You are too confused!");
#endif
		return FALSE;
	}

	if (p_ptr->blind)
	{
#ifdef JP
		msg_print("ڂȂI");
#else
		msg_print("You are blind!");
#endif
		return FALSE;
	}

	while (TRUE)
	{
		if (!get_com(com, &ch, TRUE))
		{
			return FALSE;
		}
		if (ch == 'S' || ch == 's')
		{
			ext = 1;
			break;
		}
		if ((ch == 'A' || ch == 'a')&&(p_ptr->lev >= 10))
		{
			ext = 2;
			break;
		}
		if ((ch == 'B' || ch == 'b')&&(p_ptr->lev >= 20))
		{
			ext = 3;
			break;
		}
	}

	/**********Create shots*********/
	if (ext == 1)
	{
		int x,y, dir;
		cave_type *c_ptr;

		if (!get_rep_dir(&dir, FALSE)) return FALSE;
		y = py + ddy[dir];
		x = px + ddx[dir];
		c_ptr = &cave[y][x];

		if (!have_flag(f_info[get_feat_mimic(c_ptr)].flags, FF_CAN_DIG))
		{
#ifdef JP
			msg_print("ɂ͊΂ȂB");
#else
			msg_print("You need pile of rubble.");
#endif
			return FALSE;
		}
		else if (!cave_have_flag_grid(c_ptr, FF_CAN_DIG) || !cave_have_flag_grid(c_ptr, FF_HURT_ROCK))
		{
#ifdef JP
			msg_print("dĕȂB");
#else
			msg_print("You failed to make ammo.");
#endif
		}
		else
		{
			s16b slot;

			/* Get local object */
			q_ptr = &forge;

			/* Hack -- Give the player some small firestones */
			object_prep(q_ptr, lookup_kind(TV_SHOT, m_bonus(1, p_ptr->lev) + 1));
			q_ptr->number = (byte)rand_range(15,30);
			object_aware(q_ptr);
			object_known(q_ptr);
			apply_magic(q_ptr, p_ptr->lev, AM_NO_FIXED_ART);
			q_ptr->discount = 99;

			slot = inven_carry(q_ptr);

			object_desc(o_name, q_ptr, 0);
#ifdef JP
			msg_format("%sB", o_name);
#else
			msg_print("You make some ammo.");
#endif

			/* Auto-inscription */
			if (slot >= 0) autopick_alter_item(slot, FALSE);

			/* Destroy the wall */
			cave_alter_feat(y, x, FF_HURT_ROCK);

			p_ptr->update |= (PU_FLOW);
		}
	}
	/**********Create arrows*********/
	else if (ext == 2)
	{
		int item;
		cptr q, s;
		s16b slot;
		///del131221 ̔p~Ƌɖʐ
		msg_format("͔̂p~ꂽB", o_name);
		return FALSE;
		//item_tester_hook = item_tester_hook_convertible;

		/* Get an item */
#ifdef JP
		q = "ǂ̃ACe܂H ";
		s = "ޗĂȂB";
#else
		q = "Convert which item? ";
		s = "You have no item to convert.";
#endif
		if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return FALSE;

		/* Get the item (in the pack) */
		if (item >= 0)
		{
			q_ptr = &inventory[item];
		}

		/* Get the item (on the floor) */
		else
		{
			q_ptr = &o_list[0 - item];
		}

		/* Get local object */
		q_ptr = &forge;

		/* Hack -- Give the player some small firestones */
		object_prep(q_ptr, lookup_kind(TV_ARROW, m_bonus(1, p_ptr->lev)+ 1));
		q_ptr->number = (byte)rand_range(5, 10);
		object_aware(q_ptr);
		object_known(q_ptr);
		apply_magic(q_ptr, p_ptr->lev, AM_NO_FIXED_ART);

		q_ptr->discount = 99;

		object_desc(o_name, q_ptr, 0);
#ifdef JP
		msg_format("%sB", o_name);
#else
		msg_print("You make some ammo.");
#endif

		if (item >= 0)
		{
			inven_item_increase(item, -1);
			inven_item_describe(item);
			inven_item_optimize(item);
		}
		else
		{
			floor_item_increase(0 - item, -1);
			floor_item_describe(0 - item);
			floor_item_optimize(0 - item);
		}

		slot = inven_carry(q_ptr);

		/* Auto-inscription */
		if (slot >= 0) autopick_alter_item(slot, FALSE);
	}
	/**********Create bolts*********/
	else if (ext == 3)
	{
		int item;
		cptr q, s;
		s16b slot;
		///del131221 ̔p~Ƌɖʐ
		msg_format("͔̂p~ꂽB", o_name);
		return FALSE;

		//item_tester_hook = item_tester_hook_convertible;

		/* Get an item */
#ifdef JP
		q = "ǂ̃ACe܂H ";
		s = "ޗĂȂB";
#else
		q = "Convert which item? ";
		s = "You have no item to convert.";
#endif
		if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return FALSE;

		/* Get the item (in the pack) */
		if (item >= 0)
		{
			q_ptr = &inventory[item];
		}

		/* Get the item (on the floor) */
		else
		{
			q_ptr = &o_list[0 - item];
		}

		/* Get local object */
		q_ptr = &forge;

		/* Hack -- Give the player some small firestones */
		object_prep(q_ptr, lookup_kind(TV_BOLT, m_bonus(1, p_ptr->lev)+1));
		q_ptr->number = (byte)rand_range(4, 8);
		object_aware(q_ptr);
		object_known(q_ptr);
		apply_magic(q_ptr, p_ptr->lev, AM_NO_FIXED_ART);

		q_ptr->discount = 99;

		object_desc(o_name, q_ptr, 0);
#ifdef JP
		msg_format("%sB", o_name);
#else
		msg_print("You make some ammo.");
#endif

		if (item >= 0)
		{
			inven_item_increase(item, -1);
			inven_item_describe(item);
			inven_item_optimize(item);
		}
		else
		{
			floor_item_increase(0 - item, -1);
			floor_item_describe(0 - item);
			floor_item_optimize(0 - item);
		}

		slot = inven_carry(q_ptr);

		/* Auto-inscription */
		if (slot >= 0) autopick_alter_item(slot, FALSE);
	}
	return TRUE;
}
#endif



/*:::pt̖z*/
///class
///system item ▂@_Abh̎ނ𑝌Ƃ
///mod150330 חpɏǋLύX
bool gain_magic(void)
{
	int item;
	int pval;
	int ext = 0;
	cptr q, s;
	object_type *o_ptr;
	char o_name[MAX_NLEN];

	/* Only accept legal items */
	/*:::AbhA@_*/
	item_tester_hook = item_tester_hook_recharge;

	/* Get an item */
#ifdef JP
	if(p_ptr->pclass == CLASS_SEIJA)
	{
		q = "ǂ̖B܂H ";
		s = "ĂȂB";
	}
	else
	{
		q = "ǂ̃ACe̖͂荞݂܂? ";
		s = "͂荞߂ACeȂB";
	}
#else
	q = "Gain power of which item? ";
	s = "You have nothing to gain power.";
#endif

	if (!get_item(&item, q, s, (USE_INVEN | USE_FLOOR))) return (FALSE);

	/* Get the item (in the pack) */
	if (item >= 0)
	{
		o_ptr = &inventory[item];
	}

	/* Get the item (on the floor) */
	else
	{
		o_ptr = &o_list[0 - item];
	}
	/*:::Afbh̏H̏*/
	if (o_ptr->tval == TV_STAFF && o_ptr->sval == SV_STAFF_NOTHING)
	{
#ifdef JP
		msg_print("̏ɂׂ͔̈̔\͉͂ĂȂ悤B");
#else
		msg_print("This staff doesn't have any magical ability.");
#endif
		return FALSE;
	}


	if (!object_is_known(o_ptr))
	{
#ifdef JP
	if(p_ptr->pclass == CLASS_SEIJA)
		msg_print("Ӓ肳ĂȂƈȂB");
	else
		msg_print("Ӓ肳ĂȂƎ荞߂ȂB");
#else
		msg_print("You need to identify before absorbing.");
#endif
		return FALSE;
	}

	if (o_ptr->timeout)
	{
#ifdef JP
	if(p_ptr->pclass == CLASS_SEIJA)
		msg_print("[ŨACe͈ȂB");
	else
		msg_print("[ŨACe͎荞߂ȂB");
#else
		msg_print("This item is still charging.");
#endif
		return FALSE;
	}

	pval = o_ptr->pval;
	if (o_ptr->tval == TV_ROD)
		ext = EATER_EXT*2;
	else if (o_ptr->tval == TV_WAND)
		ext = EATER_EXT;

	if (o_ptr->tval == TV_ROD)
	{
		p_ptr->magic_num2[o_ptr->sval + ext] += o_ptr->number;
		if (p_ptr->magic_num2[o_ptr->sval + ext] > 99) p_ptr->magic_num2[o_ptr->sval + ext] = 99;
	}
	else
	{
		int num;
		for (num = o_ptr->number; num; num--)
		{
			int gain_num = pval;
			if (o_ptr->tval == TV_WAND) gain_num = (pval + num - 1) / num;
			if (p_ptr->magic_num2[o_ptr->sval + ext])
			{
				gain_num *= 256;
				gain_num = (gain_num/3 + randint0(gain_num/3)) / 256;
				if (gain_num < 1) gain_num = 1;
			}
			/*:::magic_num2[]͍ő񐔁Amagic_num1[]͏[U󋵂炵*/
			p_ptr->magic_num2[o_ptr->sval + ext] += gain_num;
			if (p_ptr->magic_num2[o_ptr->sval + ext] > 99) p_ptr->magic_num2[o_ptr->sval + ext] = 99;
			p_ptr->magic_num1[o_ptr->sval + ext] += pval * 0x10000;
			if (p_ptr->magic_num1[o_ptr->sval + ext] > 99 * 0x10000) p_ptr->magic_num1[o_ptr->sval + ext] = 99 * 0x10000;
			if (p_ptr->magic_num1[o_ptr->sval + ext] > p_ptr->magic_num2[o_ptr->sval + ext] * 0x10000) p_ptr->magic_num1[o_ptr->sval + ext] = p_ptr->magic_num2[o_ptr->sval + ext] * 0x10000;
			if (o_ptr->tval == TV_WAND) pval -= (pval + num - 1) / num;
		}
	}

	object_desc(o_name, o_ptr, 0);
	/* Message */
#ifdef JP
	if(p_ptr->pclass == CLASS_SEIJA)
	{
		msg_format("%sd񂾁B", o_name);
	}
	else
		msg_format("%s̖͂荞񂾁B", o_name);

#else
	msg_format("You absorb magic of %s.", o_name);
#endif

	/* Eliminate the item (from the pack) */
	if (item >= 0)
	{
		inven_item_increase(item, -999);
		inven_item_describe(item);
		inven_item_optimize(item);
	}

	/* Eliminate the item (from the floor) */
	else
	{
		floor_item_increase(0 - item, -999);
		floor_item_describe(0 - item);
		floor_item_optimize(0 - item);
	}
	energy_use = 100;
	return TRUE;
}

/*:::@gԂǂ肷*/
static bool can_do_cmd_cast(void)
{
	if (dun_level && (d_info[dungeon_type].flags1 & DF1_NO_MAGIC))
	{
#ifdef JP
		msg_print("_W@zI");
#else
		msg_print("The dungeon absorbs all attempted magic!");
#endif
		msg_print(NULL);
		return FALSE;
	}
	else if (p_ptr->anti_magic)
	{
#ifdef JP
		msg_print("@oA@זI");
#else
		msg_print("An anti-magic shell disrupts your magic!");
#endif
		return FALSE;
	}
	else if (p_ptr->shero)
	{
#ifdef JP
		msg_format("mĂēȂI");
#else
		msg_format("You cannot think directly!");
#endif
		return FALSE;
	}
	else
		return TRUE;
}

///sys class Csm̍\
static bool choose_kamae(void)
{
	char choice;
	int new_kamae = 0;
	int i;
	char buf[80];

	if (p_ptr->confused)
	{
#ifdef JP
		msg_print("Ăč\ȂI");
#else
		msg_print("Too confused.");
#endif
		return FALSE;
	}

	/* Save screen */
	screen_save();

#ifdef JP
	prt(" a) \Ƃ", 2, 20);
#else
	prt(" a) No form", 2, 20);
#endif

	for (i = 0; i < MAX_KAMAE; i++)
	{
		if (p_ptr->lev >= kamae_shurui[i].min_level)
		{
			sprintf(buf," %c) %-12s  %s",I2A(i+1), kamae_shurui[i].desc, kamae_shurui[i].info);
			prt(buf, 3+i, 20);
		}
	}

	prt("", 1, 0);
#ifdef JP
	prt("        ǂ̍\Ƃ܂H", 1, 14);
#else
	prt("        Choose Form: ", 1, 14);
#endif

	while(1)
	{
		choice = inkey();

		if (choice == ESCAPE)
		{
			screen_load();
			return FALSE;
		}
		else if ((choice == 'a') || (choice == 'A'))
		{
			if (p_ptr->action == ACTION_KAMAE)
			{
				set_action(ACTION_NONE);
			}
			else
#ifdef JP
				msg_print("Ƃƍ\ĂȂB");
#else
				msg_print("You are not assuming a posture.");
#endif
			screen_load();
			return TRUE;
		}
		else if ((choice == 'b') || (choice == 'B'))
		{
			new_kamae = 0;
			break;
		}
		else if (((choice == 'c') || (choice == 'C')) && (p_ptr->lev > 29))
		{
			new_kamae = 1;
			break;
		}
		else if (((choice == 'd') || (choice == 'D')) && (p_ptr->lev > 34))
		{
			new_kamae = 2;
			break;
		}
		else if (((choice == 'e') || (choice == 'E')) && (p_ptr->lev > 39))
		{
			new_kamae = 3;
			break;
		}
	}
	set_action(ACTION_KAMAE);

	if (p_ptr->special_defense & (KAMAE_GENBU << new_kamae))
	{
#ifdef JP
		msg_print("\B");
#else
		msg_print("You reassume a posture.");
#endif
	}
	else
	{
		p_ptr->special_defense &= ~(KAMAE_MASK);
		p_ptr->update |= (PU_BONUS);
		p_ptr->redraw |= (PR_STATE);
#ifdef JP
		msg_format("%s̍\ƂB",kamae_shurui[new_kamae].desc);
#else
		msg_format("You assume a posture of %s form.",kamae_shurui[new_kamae].desc);
#endif
		p_ptr->special_defense |= (KAMAE_GENBU << new_kamae);
	}
	p_ptr->redraw |= PR_STATE;
	screen_load();
	return TRUE;
}

/*:::pƂ̌^I*/
bool choose_samurai_kata(void)
{
	char choice;
	int new_kata = 0;
	int i;
	char buf[80];

	if (p_ptr->confused)
	{
#ifdef JP
		msg_print("Ăč\ȂI");
#else
		msg_print("Too confused.");
#endif
		return FALSE;
	}

	if (p_ptr->stun)
	{
#ifdef JP
		msg_print("ӎ͂ƂȂB");
#else
		msg_print("You are not clear headed");
#endif
		return FALSE;
	}

	if (p_ptr->afraid)
	{
#ifdef JP
		msg_print("̂kč\ȂI");
#else
		msg_print("You are trembling with fear!");
#endif
		return FALSE;
	}

	/* Save screen */
	screen_save();

#ifdef JP
	prt(" a) ^", 2, 20);
#else
	prt(" a) No Form", 2, 20);
#endif

	for (i = 0; i < MAX_KATA; i++)
	{
		if (p_ptr->lev >= kata_shurui[i].min_level)
		{
#ifdef JP
			sprintf(buf," %c) %š^    %s",I2A(i+1), kata_shurui[i].desc, kata_shurui[i].info);
#else
			sprintf(buf," %c) Form of %-12s  %s",I2A(i+1), kata_shurui[i].desc, kata_shurui[i].info);
#endif
			prt(buf, 3+i, 20);
		}
	}

	prt("", 1, 0);
#ifdef JP
	prt("        ǂ̌^ō\܂H", 1, 14);
#else
	prt("        Choose Form: ", 1, 14);
#endif

	while(1)
	{
		choice = inkey();

		if (choice == ESCAPE)
		{
			screen_load();
			return FALSE;
		}
		else if ((choice == 'a') || (choice == 'A'))
		{
			if (p_ptr->action == ACTION_KATA)
			{
				set_action(ACTION_NONE);
			}
			else
#ifdef JP
				msg_print("Ƃƍ\ĂȂB");
#else
				msg_print("You are not assuming posture.");
#endif
			screen_load();
			return TRUE;
		}
		else if ((choice == 'b') || (choice == 'B'))
		{
			new_kata = 0;
			break;
		}
		else if (((choice == 'c') || (choice == 'C')) && (p_ptr->lev > 29))
		{
			new_kata = 1;
			break;
		}
		else if (((choice == 'd') || (choice == 'D')) && (p_ptr->lev > 34))
		{
			new_kata = 2;
			break;
		}
		else if (((choice == 'e') || (choice == 'E')) && (p_ptr->lev > 39))
		{
			new_kata = 3;
			break;
		}
	}
	set_action(ACTION_KATA);

	if (p_ptr->special_defense & (KATA_IAI << new_kata))
	{
#ifdef JP
		msg_print("\B");
#else
		msg_print("You reassume a posture.");
#endif
	}
	else
	{
		p_ptr->special_defense &= ~(KATA_MASK);
		p_ptr->update |= (PU_BONUS);
		p_ptr->update |= (PU_MONSTERS);
#ifdef JP
		msg_format("%š^ō\B",kata_shurui[new_kata].desc);
#else
		msg_format("You assume a posture of %s form.",kata_shurui[new_kata].desc);
#endif
		p_ptr->special_defense |= (KATA_IAI << new_kata);
	}
	p_ptr->redraw |= (PR_STATE);
	p_ptr->redraw |= (PR_STATUS);
	screen_load();
	return TRUE;
}


/*
 * Returns the chance to activate a racial power/mutation
 */
static int racial_chance(power_desc_type *pd_ptr)
{
	s16b min_level  = pd_ptr->level;
	int  difficulty = pd_ptr->fail;

	int i;
	int val;
	int sum = 0;
	int stat = p_ptr->stat_cur[pd_ptr->stat];

	///mod140126 p[^ύXstat_cur18/***l~߂̂łōČvZ
	if(p_ptr->stat_cur[pd_ptr->stat] > 18) stat = 18 + (p_ptr->stat_cur[pd_ptr->stat] - 18) * 10;

	/* No chance for success */
	if ((p_ptr->lev < min_level) || p_ptr->confused)
	{
		return (0);
	}

	if (difficulty == 0) return 100;

	/* Calculate difficulty */
	if (p_ptr->stun)
	{
		difficulty += p_ptr->stun;
	}
	else if (p_ptr->lev > min_level)
	{
		int lev_adj = ((p_ptr->lev - min_level) / 3);
		if (lev_adj > 10) lev_adj = 10;
		difficulty -= lev_adj;
	}

	if (difficulty < 5) difficulty = 5;

	/* We only need halfs of the difficulty */
	///pend CV̐vZ@p[^18/***\LύXߑ傫ςKv邩ȂĂȂ
	difficulty = difficulty / 2;

	for (i = 1; i <= stat; i++)
	{
		val = i - difficulty;
		if (val > 0)
			sum += (val <= difficulty) ? val : difficulty;
	}

	if (difficulty == 0)
		return (100);
	else
		return (((sum * 100) / difficulty) / stat);
}


static int  racial_cost;

/*
 * Note: return value indicates that we have succesfully used the power
 * 1: Succeeded, 0: Cancelled, -1: Failed
 */
/*:::CVp[̐*/
static int racial_aux(power_desc_type *pd_ptr)
{
	s16b min_level  = pd_ptr->level;
	int  difficulty = pd_ptr->fail;
	int  use_hp = 0;
	int stat = p_ptr->stat_cur[pd_ptr->stat];

	racial_cost = pd_ptr->cost;


	///mod140126 p[^ύXstat_cur18/***l~߂̂łōČvZ
	if(p_ptr->stat_cur[pd_ptr->stat] > 18) stat = 18 + (p_ptr->stat_cur[pd_ptr->stat] - 18) * 10;

	/* Not enough mana - use hp */
	if (p_ptr->csp < racial_cost) use_hp = racial_cost - p_ptr->csp;

	/* Power is not available yet */
	if (p_ptr->lev < min_level)
	{
#ifdef JP
		msg_format("̔\͂gpɂ̓x %d ɒBĂȂ΂Ȃ܂B", min_level);
#else
		msg_format("You need to attain level %d to use this power.", min_level);
#endif

		energy_use = 0;
		return 0;
	}

	/* Too confused */
	else if (p_ptr->confused)
	{
#ifdef JP
		msg_print("ĂĂ̔\͎͂gȂB");
#else
		msg_print("You are too confused to use this power.");
#endif

		energy_use = 0;
		return 0;
	}

	/* Risk death? */
	else if (p_ptr->chp < use_hp)
	{
#ifdef JP
		if (!get_check("{ɍ̐サԂł̔\͂g܂H"))
#else
		if (!get_check("Really use the power in your weakened state? "))
#endif
		{
			energy_use = 0;
			return 0;
		}
	}

	/* Else attempt to do it! */

	if (difficulty)
	{
		if (p_ptr->stun)
		{
			difficulty += p_ptr->stun;
		}
		else if (p_ptr->lev > min_level)
		{
			int lev_adj = ((p_ptr->lev - min_level) / 3);
			if (lev_adj > 10) lev_adj = 10;
			difficulty -= lev_adj;
		}

		if (difficulty < 5) difficulty = 5;
	}

	/* take time and pay the price */
	energy_use = 100;



	/* Success? */
	if (randint1(stat) >=
	    ((difficulty / 2) + randint1(difficulty / 2)))
	{
		return 1;
	}

	if (flush_failure) flush();
#ifdef JP
	msg_print("[ɏWłȂB");
#else
	msg_print("You've failed to concentrate hard enough.");
#endif

	return -1;
}


/*:::r̂ĂƂI鏈*/
void ratial_stop_mouth()
{
	if (music_singing_any()) stop_singing();
	if (hex_spelling_any()) stop_hex_spell_all();
}


/*:::EƁA푰Ƃ̃CVʔ@ꂼނĂȂ*/
//͂łȂ
static bool cmd_racial_power_aux(s32b command)
{
	s16b        plev = p_ptr->lev;
	int         dir = 0;

///mod140202 EƃCVSĔp~
#if 0
	if (command <= -3)
	{
		switch (p_ptr->pclass)
		{
		case CLASS_WARRIOR:
		{
			int y = 0, x = 0, i;
			cave_type       *c_ptr;

			for (i = 0; i < 6; i++)
			{
				dir = randint0(8);
				y = py + ddy_ddd[dir];
				x = px + ddx_ddd[dir];
				c_ptr = &cave[y][x];

				/* Hack -- attack monsters */
				if (c_ptr->m_idx)
					py_attack(y, x, 0);
				else
				{
#ifdef JP
					msg_print("UB");
#else
					msg_print("You attack the empty air.");
#endif
				}
			}
			break;
		}
		/*:::pȊÕnCCW͂̂܂܉ɍsĖ͐H*/
		case CLASS_HIGH_MAGE:
		if (p_ptr->realm1 == REALM_HEX)
		{
			bool retval = stop_hex_spell();
			if (retval) energy_use = 10;
			return (retval);
		}
		case CLASS_MAGE:
		/* case CLASS_HIGH_MAGE: */
		case CLASS_SORCERER:
		{
			if (!eat_magic(p_ptr->lev * 2)) return FALSE;
			break;
		}
		case CLASS_PRIEST:
		{
			if (is_good_realm(p_ptr->realm1))
			{
				if (!bless_weapon()) return FALSE;
			}
			else
			{

				(void)dispel_monsters(plev * 4);
				turn_monsters(plev * 4);
				banish_monsters(plev * 4);
			}
			break;
		}
		///sys qbgAEFC
		case CLASS_ROGUE:
		{
			int x, y;

			if (!get_rep_dir(&dir, FALSE)) return FALSE;
			y = py + ddy[dir];
			x = px + ddx[dir];
			if (cave[y][x].m_idx)
			{
				py_attack(y, x, 0);
				if (randint0(p_ptr->skill_dis) < 7)
#ifdef JP
					msg_print("܂ȂB");
#else
					msg_print("You are failed to run away.");
#endif
				else teleport_player(30, 0L);
			}
			else
			{
#ifdef JP
				msg_print("̕ɂ̓X^[͂܂B");
#else
				msg_print("You don't see any monster in this direction");
#endif

				msg_print(NULL);
			}
			break;
		}
		case CLASS_RANGER:
		case CLASS_SNIPER:
		{
#ifdef JP
			msg_print("G𒲍...");
#else
			msg_print("You examine your foes...");
#endif

			probing();
			break;
		}
		case CLASS_PALADIN:
		{
			if (!get_aim_dir(&dir)) return FALSE;
			fire_beam(is_good_realm(p_ptr->realm1) ? GF_HOLY_FIRE : GF_HELL_FIRE,
			          dir, plev * 3);
			break;
		}
		case CLASS_WARRIOR_MAGE:
		{
			if (command == -3)
			{
#ifdef JP
				int gain_sp = take_hit(DAMAGE_USELIFE, p_ptr->lev, "goloւ̖dȕϊ", -1) / 5;
#else
				int gain_sp = take_hit(DAMAGE_USELIFE, p_ptr->lev, "thoughtless convertion from HP to SP", -1) / 5;
#endif
				if (gain_sp)
				{
					p_ptr->csp += gain_sp;
					if (p_ptr->csp > p_ptr->msp)
					{
						p_ptr->csp = p_ptr->msp;
						p_ptr->csp_frac = 0;
					}
				}
				else
#ifdef JP
					msg_print("ϊɎsB");
#else
					msg_print("You failed to convert.");
#endif
			}
			else if (command == -4)
			{
				if (p_ptr->csp >= p_ptr->lev / 5)
				{
					p_ptr->csp -= p_ptr->lev / 5;
					hp_player(p_ptr->lev);
				}
				else
#ifdef JP
					msg_print("ϊɎsB");
#else
					msg_print("You failed to convert.");
#endif
			}

			/* Redraw mana and hp */
			p_ptr->redraw |= (PR_HP | PR_MANA);

			break;
		}

		case CLASS_CHAOS_WARRIOR:
		{
#ifdef JP
			msg_print("ӂɂ...");
#else
			msg_print("You glare nearby monsters...");
#endif
			slow_monsters(p_ptr->lev);
			stun_monsters(p_ptr->lev * 4);
			confuse_monsters(p_ptr->lev * 4);
			turn_monsters(p_ptr->lev * 4);
			stasis_monsters(p_ptr->lev * 4);
			break;
		}
		case CLASS_MONK:
		{
			if (!(empty_hands(TRUE) & EMPTY_HAND_RARM))
			{
#ifdef JP
				msg_print("f肶ȂƂł܂B");
#else
				msg_print("You need to be bare hand.");
#endif
				return FALSE;
			}
			if (p_ptr->riding)
			{
#ifdef JP
				msg_print("n͂ł܂B");
#else
				msg_print("You need to get off a pet.");
#endif
				return FALSE;
			}

			if (command == -3)
			{
				if (!choose_kamae()) return FALSE;
				p_ptr->update |= (PU_BONUS);
			}
			else if (command == -4)
			{
				int x, y;

				if (!get_rep_dir(&dir, FALSE)) return FALSE;
				y = py + ddy[dir];
				x = px + ddx[dir];
				if (cave[y][x].m_idx)
				{
#ifdef JP
					if (one_in_(2)) msg_print("[III");
					else msg_print("IIIIIIIIIIIIIII");
#else
					if (one_in_(2)) msg_print("Ahhhtatatatatatatatatatatatatatataatatatatattaaaaa!!!!");
					else msg_print("Oraoraoraoraoraoraoraoraoraoraoraoraoraoraoraoraora!!!!");
#endif
					/*:::xUAŃX^[łȂ΂xU@ǂɂĂenergy{*/
					py_attack(y, x, 0);
					if (cave[y][x].m_idx)
					{
						handle_stuff();
						py_attack(y, x, 0);
					}
					p_ptr->energy_need += ENERGY_NEED();
				}
				else
				{
#ifdef JP
					msg_print("̕ɂ̓X^[͂܂B");
#else
					msg_print("You don't see any monster in this direction");
#endif

					msg_print(NULL);
				}
			}
			break;
		}
		/*:::~*/
		case CLASS_MINDCRAFTER:
		case CLASS_FORCETRAINER:
		{
			if (total_friends)
			{
#ifdef JP
				///msg131217
				msg_print("͔ẑƂɏWĂȂƁB");
				//msg_print("̓ybg𑀂邱ƂɏWĂȂƁB");
#else
				msg_print("You need concentration on the pets now.");
#endif
				return FALSE;
			}
#ifdef JP
			msg_print("nbLB");
#else
			msg_print("You feel your head clear a little.");
#endif

			p_ptr->csp += (3 + p_ptr->lev/20);
			if (p_ptr->csp >= p_ptr->msp)
			{
				p_ptr->csp = p_ptr->msp;
				p_ptr->csp_frac = 0;
			}

			/* Redraw mana */
			p_ptr->redraw |= (PR_MANA);
			break;
		}
		case CLASS_TOURIST:
		{
			if (command == -3)
			{
				if (!get_aim_dir(&dir)) return FALSE;
				project_length = 1;
				fire_beam(GF_PHOTO, dir, 1);
			}
			else if (command == -4)
			{
				if (!identify_fully(FALSE)) return FALSE;
			}
			break;
		}
		case CLASS_IMITATOR:
		{
			handle_stuff();
			if (!do_cmd_mane(TRUE)) return FALSE;
			break;
		}
		case CLASS_BEASTMASTER:
		{
			if (command == -3)
			{
				if (!get_aim_dir(&dir)) return FALSE;
				(void)fire_ball_hide(GF_CONTROL_LIVING, dir, p_ptr->lev, 0);
			}
			else if (command == -4)
			{
				project_hack(GF_CONTROL_LIVING, p_ptr->lev);
			}
			break;
		}
		case CLASS_ARCHER:
		{
		msg_print("A[`[̖ʐ͖B");
		return FALSE;
		//if (!do_cmd_archer()) return FALSE;
			break;
		}
		case CLASS_MAGIC_EATER:
		{
			if (command == -3) {
				if (!gain_magic()) return FALSE;
			} else if (command == -4) {
				if (!can_do_cmd_cast()) return FALSE;
				if (!do_cmd_magic_eater(FALSE, TRUE)) return FALSE;
			}
			break;
		}
		case CLASS_BARD:
		{
			/* Singing is already stopped */
			if (!p_ptr->magic_num1[0] && !p_ptr->magic_num1[1]) return FALSE;

			stop_singing();
			energy_use = 10;
			break;
		}
		case CLASS_RED_MAGE:
		{
			if (!can_do_cmd_cast()) return FALSE;
			handle_stuff();
			do_cmd_cast();
			handle_stuff();
			if (!p_ptr->paralyzed && can_do_cmd_cast())
				do_cmd_cast();
			break;
		}
		case CLASS_SAMURAI:
		{
			if (command == -3)
			{
				int max_csp = MAX(p_ptr->msp*4, p_ptr->lev*5+5);

				if (total_friends)
				{
#ifdef JP
					///msg131217
					//msg_print("̓ybg𑀂邱ƂɏWĂȂƁB");
					msg_print("͔ẑƂɏWĂȂƁB");
#else
					msg_print("You need concentration on the pets now.");
#endif
					return FALSE;
				}
				if (p_ptr->special_defense & KATA_MASK)
				{
#ifdef JP
					msg_print("͍\ɏWĂB");
#else
					msg_print("You need concentration on your form.");
#endif
					return FALSE;
				}
#ifdef JP
				msg_print("_WċC𗭂߂B");
#else
				msg_print("You concentrate to charge your power.");
#endif

				p_ptr->csp += p_ptr->msp / 2;
				if (p_ptr->csp >= max_csp)
				{
					p_ptr->csp = max_csp;
					p_ptr->csp_frac = 0;
				}

				/* Redraw mana */
				p_ptr->redraw |= (PR_MANA);
			}
			else if (command == -4)
			{
				if (!buki_motteruka(INVEN_RARM) && !buki_motteruka(INVEN_LARM))
				{
#ifdef JP
					msg_print("ȂƂ܂B");
#else
					msg_print("You need to wield a weapon.");
#endif
					return FALSE;
				}
				if (!choose_kata()) return FALSE;
				p_ptr->update |= (PU_BONUS);
			}
			break;
		}
		case CLASS_BLUE_MAGE:
		{
			if (p_ptr->action == ACTION_LEARN)
			{
				set_action(ACTION_NONE);
			}
			else
			{
				set_action(ACTION_LEARN);
			}
			energy_use = 0;
			break;
		}
		case CLASS_CAVALRY:
		{
			char m_name[80];
			monster_type *m_ptr;
			monster_race *r_ptr;
			int rlev;

			if (p_ptr->riding)
			{
#ifdef JP
				msg_print("͏nB");
#else
				msg_print("You ARE riding.");
#endif
				return FALSE;
			}
			if (!do_riding(TRUE)) return TRUE;
			m_ptr = &m_list[p_ptr->riding];
			r_ptr = &r_info[m_ptr->r_idx];
			monster_desc(m_name, m_ptr, 0);
#ifdef JP
			msg_format("%sɏB",m_name);
#else
			msg_format("You ride on %s.",m_name);
#endif
			///sys rn炵@nZ\
			if (is_pet(m_ptr)) break;
			rlev = r_ptr->level;
			if (r_ptr->flags1 & RF1_UNIQUE) rlev = rlev * 3 / 2;
			if (rlev > 60) rlev = 60+(rlev-60)/2;
			///mod131226 skill Z\ƕZ\̓
		//	if ((randint1(p_ptr->skill_exp[GINOU_RIDING] / 120 + p_ptr->lev * 2 / 3) > rlev)
			if ((randint1(ref_skill_exp(SKILL_RIDING) / 120 + p_ptr->lev * 2 / 3) > rlev)
				&& one_in_(2) && !p_ptr->inside_arena && !p_ptr->inside_battle
			    && !(r_ptr->flags7 & (RF7_GUARDIAN)) && !(r_ptr->flags1 & (RF1_QUESTOR))
			    && (rlev < p_ptr->lev * 3 / 2 + randint0(p_ptr->lev / 5)))
			{
#ifdef JP
				msg_format("%sȂB",m_name);
#else
				msg_format("You tame %s.",m_name);
#endif
				set_pet(m_ptr);
			}
			else
			{
#ifdef JP
				msg_format("%sɐU藎ƂꂽI",m_name);
#else
				msg_format("You have thrown off by %s.",m_name);
#endif
				rakuba(1,TRUE);

				/* Paranoia */
				/* nɎsĂƂɂn */
				p_ptr->riding = 0;
			}
			break;
		}
		case CLASS_BERSERKER:
		{
			if (!word_of_recall()) return FALSE;
			break;
		}
		case CLASS_SMITH:
		{
			if (p_ptr->lev > 29)
			{
				if (!identify_fully(TRUE)) return FALSE;
			}
			else
			{
				if (!ident_spell(TRUE)) return FALSE;
			}
			break;
		}
		case CLASS_MIRROR_MASTER:
		{
			if (command == -3)
			{
				/* Explode all mirrors */
				remove_all_mirrors(TRUE);
			}
			else if (command == -4)
			{
				if (total_friends)
				{
#ifdef JP
					msg_print("̓ybg𑀂邱ƂɏWĂȂƁB");
#else
					msg_print("You need concentration on the pets now.");
#endif
					return FALSE;
				}
				if (is_mirror_grid(&cave[py][px]))
				{
#ifdef JP
					msg_print("nbLB");
#else
					msg_print("You feel your head clear a little.");
#endif

					p_ptr->csp += (5 + p_ptr->lev * p_ptr->lev / 100);
					if (p_ptr->csp >= p_ptr->msp)
					{
						p_ptr->csp = p_ptr->msp;
						p_ptr->csp_frac = 0;
					}

					/* Redraw mana */
					p_ptr->redraw |= (PR_MANA);
				}
				else
				{
#ifdef JP
					msg_print("̏łȂƏWłȂI");
#else
					msg_print("Here are not any mirrors!");
#endif
				}
			}
			break;
		}
		case CLASS_NINJA:
		{
			if (p_ptr->action == ACTION_HAYAGAKE)
			{
				set_action(ACTION_NONE);
			}
			else
			{
				cave_type *c_ptr = &cave[py][px];
				feature_type *f_ptr = &f_info[c_ptr->feat];

				if (!have_flag(f_ptr->flags, FF_PROJECT) ||
				    (!p_ptr->levitation && have_flag(f_ptr->flags, FF_DEEP)))
				{
#ifdef JP
					msg_print("ł͑fȂB");
#else
					msg_print("You cannot run in here.");
#endif
				}
				else
				{
					set_action(ACTION_HAYAGAKE);
				}
			}


			energy_use = 0;
			break;
		}

		}
	}
	else 
#endif


	if(p_ptr->clawextend && command == -100)
	{

		cave_type       *c_ptr;
		monster_type    *m_ptr;
		monster_race	*r_ptr;
		int x,y;

		for (dir = 0; dir < 8; dir++)
		{
			y = py + ddy_ddd[dir];
			x = px + ddx_ddd[dir];
			c_ptr = &cave[y][x];

			m_ptr = &m_list[c_ptr->m_idx];
			/*:::s̃X^[U邪Aǂ̒ɂs̃X^[͍UȂ*/
			if (c_ptr->m_idx && (m_ptr->ml || cave_have_flag_bold(y, x, FF_PROJECT)))
			{

				py_attack(y, x, HISSATSU_EXCLAW);

			}
		}

	}
	//command-101`-104EXTRA[h̃ACeJ[h֌WR}hɂ
	else if(command == -101) //J[hZbg
	{
		if(!set_itemcard()) return FALSE;
	}
	else if(command == -102) //J[hgp
	{
		if(!activate_itemcard()) return FALSE;
	}
	else if(command == -103) //J[hO
	{
		if(!remove_itemcard()) return FALSE;
	}
	else if(command == -104) //J[hǂ
	{
		read_itemcard();
		return FALSE;
	}
	else if(command == -105) //iC̋A
	{
		if (!word_of_recall()) return FALSE;
	}

	else if (p_ptr->mimic_form)
	{
		switch (p_ptr->mimic_form)
		{
		case MIMIC_DEMON:
		case MIMIC_DEMON_LORD:
		{
			int type = (one_in_(2) ? GF_NETHER : GF_FIRE);
			if (!get_aim_dir(&dir)) return FALSE;
			ratial_stop_mouth();
#ifdef JP
			msg_format("Ȃ%s̃uXfB",((type == GF_NETHER) ? "n" : "Ή"));
#else
			msg_format("You breathe %s.",((type == GF_NETHER) ? "nether" : "fire"));
#endif

			fire_ball(type, dir, plev * 3, -(plev / 15) - 1);
			break;
		}
		case MIMIC_VAMPIRE:
			if (d_info[dungeon_type].flags1 & DF1_NO_MELEE)
			{
#ifdef JP
				msg_print("ȂU邱ƂłȂB");
#else
				msg_print("Something prevent you from attacking.");
#endif
				return FALSE;
			}
			else
			{
				int y, x, dummy = 0;
				cave_type *c_ptr;

				/* Only works on adjacent monsters */
				if (!get_rep_dir(&dir, FALSE)) return FALSE;   /* was get_aim_dir */
				y = py + ddy[dir];
				x = px + ddx[dir];
				c_ptr = &cave[y][x];

				ratial_stop_mouth();

				if (!c_ptr->m_idx)
				{
#ifdef JP
					msg_print("ȂꏊɊ݂I");
#else
					msg_print("You bite into thin air!");
#endif

					break;
				}

#ifdef JP
				msg_print("Ȃ̓jƂĉނ...");
#else
				msg_print("You grin and bare your fangs...");
#endif

				dummy = plev + randint1(plev) * MAX(1, plev / 10);   /* Dmg */
				if (drain_life(dir, dummy))
				{
					if (p_ptr->food < PY_FOOD_FULL)
						/* No heal if we are "full" */
						(void)hp_player(dummy);
					else
#ifdef JP
						msg_print("Ȃ͋󕠂ł͂܂B");
#else
						msg_print("You were not hungry.");
#endif

					/* Gain nutritional sustenance: 150/hp drained */
					/* A Food ration gives 5000 food points (by contrast) */
					/* Don't ever get more than "Full" this way */
					/* But if we ARE Gorged,  it won't cure us */
					dummy = p_ptr->food + MIN(5000, 100 * dummy);
					if (p_ptr->food < PY_FOOD_MAX)   /* Not gorged already */
						(void)set_food(dummy >= PY_FOOD_MAX ? PY_FOOD_MAX - 1 : dummy);
				}
				else
#ifdef JP
					msg_print("BЂǂB");
#else
					msg_print("Yechh. That tastes foul.");
#endif

			}
			break;
		case MIMIC_SHINMYOU:
		case MIMIC_GIGANTIC:
			{
				set_mimic(0,0,TRUE);
			}
			break;

		case MIMIC_BEAST:
			if(command == -1)
			{
				set_mimic(0,0,TRUE);
			}
			else if(command == -2)
			{
				msg_print("낵т_WɋI");
				(void)set_afraid(0);
				(void)set_shero(10 + randint1(plev), FALSE);
				confuse_monsters(p_ptr->lev * 2);
				turn_monsters(p_ptr->lev * 4);
				(void)aggravate_monsters(0,FALSE);
			}
			/*:::ːi@ruch_attack()*/
			else
			{
				int dir;
				int tx, ty;
				u16b path_g[32];
				int path_n, i;
				bool moved = FALSE;

				project_length = 5;
				if (!get_aim_dir(&dir)) return FALSE;
				tx = px + project_length * ddx[dir];
				ty = py + project_length * ddy[dir];
				if ((dir == 5) && target_okay())
				{
					tx = target_col;
					ty = target_row;
				}

				if (in_bounds(ty, tx)) msg_format("Ȃ͖җȓːiI");

				path_n = project_path(path_g, project_length, py, px, ty, tx, PROJECT_THRU | PROJECT_KILL);
				project_length = 0;
				if (!path_n) return FALSE;
				ty = py;
				tx = px;

				/* Project along the path */
				for (i = 0; i < path_n; i++)
				{
					monster_type *m_ptr;
					monster_race *r_ptr;
					char m_name[80];
					bool stop = FALSE;

					int ny = GRID_Y(path_g[i]);
					int nx = GRID_X(path_g[i]);
	
					if (cave[ny][nx].m_idx)
					{
						m_ptr = &m_list[cave[ny][nx].m_idx];
						r_ptr = &r_info[m_ptr->r_idx];
						monster_desc(m_name, m_ptr, 0);

						if(d_info[dungeon_type].flags1 & DF1_NO_MELEE)
						{
							msg_format("Ȃ%s̒Oő~܂B",m_name);
							break;
						}						
						else if(r_ptr->flags2 & RF2_GIGANTIC)
						{			
							msg_format("%sɓːi~߂ꂽI",m_name);
							(void)project(0, 0, ny, nx, p_ptr->lev * 3, GF_MISSILE, PROJECT_HIDE|PROJECT_KILL, -1);
							break;
						}
						else 
						{
							msg_format("%se΂I",m_name);
							(void)project(0, 0, ny, nx, p_ptr->lev * 3, GF_MISSILE, PROJECT_HIDE|PROJECT_KILL, -1);
							if(cave[ny][nx].m_idx) teleport_away(cave[ny][nx].m_idx, 5,TELEPORT_PASSIVE);
						}

					}
					if (cave_empty_bold(ny, nx) && player_can_enter(cave[ny][nx].feat, 0))
					{
						ty = ny;
						tx = nx;
					}
					else 
					{
						msg_print("ɂ͓ȂB");
						break;
					}

				}

				if (!player_bold(ty, tx)) teleport_player_to(ty, tx, TELEPORT_NONMAGICAL);

			}
			break;
		case MIMIC_SLIME:
			if(command == -1)
			{
				set_mimic(0,0,TRUE);
			}
			else if(command == -2)
			{
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͎_̃uXfB");
				//v1.1.31 MINMAXԈႦĂ̂ŏC
				fire_ball(GF_ACID, dir, MAX(p_ptr->chp/3,1), -(plev / 15) - 1);
			}
			break;


		case MIMIC_MARISA:
			if(command == -1)
			{
				set_mimic(0,0,TRUE);
			}
			else if(command == -2)
			{
				int dir;
				int damage = p_ptr->lev * 3;
				if (!get_aim_dir(&dir)) return FALSE;
				fire_beam(GF_NUKE, dir, damage);
			}
			else if(command == -3)
			{
				int len=p_ptr->lev / 7;
				int damage =  p_ptr->lev * 2;
				if (!rush_attack2(len,GF_MISSILE,damage)) return FALSE;
			}
			else if(command == -4)
			{
				int dir;
				int damage = p_ptr->lev * 7;
				if (!get_aim_dir(&dir)) return FALSE;
				fire_spark(GF_DISINTEGRATE,dir,damage,1);
			}

			break;
		case MIMIC_MIST:
			if(command == -1)
			{
				set_mimic(0,0,TRUE);
			}
			else if(command == -2)
			{
				msg_print("ǂֈړ܂H");
				if (!dimension_door(D_DOOR_MIST)) return FALSE;
			}
			break;


		case MIMIC_DRAGON:
			if(command == -1)
			{
				set_mimic(0,0,TRUE);
			}
			else if(command == -2)
			{
				int dam = MIN(1600,p_ptr->chp/3);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͉Ή̃uXfB");
				fire_ball(GF_FIRE, dir, dam, -4);
			}
			else if(command == -3)
			{
				int dam = MIN(1200,p_ptr->chp/4);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ̓vY}̃uXfB");
				fire_ball(GF_PLASMA, dir, dam, -4);
			}
			else if(command == -4)
			{
				int dam = MIN(1000,p_ptr->chp/4);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͊jM̃uXfB");
				fire_ball(GF_NUKE, dir, dam, -4);
			}
			else if(command == -5)
			{
				int dam = MIN(450,p_ptr->chp/6);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͏Ռg̃uXfB");
				fire_ball(GF_SOUND, dir, dam, -4);
			}
			else if(command == -6)
			{
				int dam = MIN(600,p_ptr->chp/6);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ̓JIX̃uXfB");
				fire_ball(GF_CHAOS, dir, dam, -4);
			}
			else if(command == -7)
			{
				int dam = MIN(600,p_ptr->chp/7);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͈ʍ̃uXfB");
				fire_ball(GF_NEXUS, dir, dam, -4);
			}
			else if(command == -8)
			{
				int dam = MIN(555,p_ptr->chp/6);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͍k^LIq̃uXfI");
				fire_spark(GF_DISINTEGRATE,dir,dam,2);
			}

			else if(command == -9)
			{
				int dam = MIN(1600,p_ptr->chp/3);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͓d̃uXfB");
				fire_ball(GF_ELEC, dir, dam, -4);
			}
			else if(command == -10)
			{
				int dam = MIN(1600,p_ptr->chp/3);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͗C̃uXfB");
				fire_ball(GF_COLD, dir, dam, -4);
			}
			else if(command == -11)
			{
				int dam = MIN(1600,p_ptr->chp/3);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͎_̃uXfB");
				fire_ball(GF_ACID, dir, dam, -4);
			}

			else if(command == -12)
			{
				msg_print("ǂɔт܂H");
				if (!dimension_door(D_DOOR_DRAGON)) return FALSE;
			}
			break;
		case MIMIC_CAT:
			if(command == -1)
			{
				set_mimic(0,0,TRUE);
			}
			break;
		case MIMIC_METAMORPHOSE_NORMAL:
		case MIMIC_METAMORPHOSE_MONST:
		case MIMIC_METAMORPHOSE_GIGANTIC:
			if(command == -1)
			{
				screen_save();
				screen_roff(MON_EXTRA_FIELD, 0x01);//ׂĂ̏𓾂
				inkey();
				screen_load();
				return FALSE;

			}
			else if(command == -2)
			{
				p_ptr->special_defense &= ~(SD_METAMORPHOSIS);
				p_ptr->special_flags &= ~(SPF_IGNORE_METAMOR_TIME);

				set_mimic(0,0,TRUE);
			}
			else if(command == -3)
			{
				if(!cast_monspell_new()) return FALSE;
			}
			break;
		case MIMIC_NUE:
			if(command == -1)
			{
				msg_print("Ȃ͏uɏB");
				teleport_player(10, 0L);
			}
			else if(command == -2)
			{
				msg_print("sgȖӂɋEE");
				confuse_monsters(plev * 3);
				turn_monsters(50 + plev * 3);
			}
			else if(command == -3)
			{
				int dam = MIN(300,p_ptr->chp/5);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("ȂᏋCfB");
				fire_ball(GF_POIS, dir, dam, -3);
			}
			else if(command == -4)
			{
				if (!get_aim_dir(&dir)) return FALSE;		
				if(!fire_ball_jump(GF_ELEC,dir,plev*5,3,"I")) return FALSE;
			}
			else if(command == -5)
			{
				int dam = MIN(400,p_ptr->chp/4);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃ͈ÍfB");
				fire_ball(GF_DARK, dir, dam, -3);
			}
			else if(command == -6)
			{
				int dam = MIN(600,p_ptr->chp/3);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
				msg_format("Ȃׂ͍fB");
				fire_ball(GF_CHAOS, dir, dam, -3);
			}
			break;






		}



	}

	else 
	{
/*:::푰ƃCV@ϐg*/
	switch (p_ptr->prace)
	{
		case RACE_SENNIN:
		case RACE_TENNIN:
			//~
			if (total_friends)
			{
#ifdef JP
				msg_print("͔ẑƂɏWĂȂƁB");
#endif
				return FALSE;
			}
#ifdef JP
			msg_print("nbLB");
#endif
			p_ptr->csp += (3 + p_ptr->lev/20);
			if (p_ptr->csp >= p_ptr->msp)
			{
				p_ptr->csp = p_ptr->msp;
				p_ptr->csp_frac = 0;
			}
			p_ptr->redraw |= (PR_MANA);
			break;
		case RACE_KAPPA:
			//SC
			if(command == -1)
			{
				int dice = 3 + (plev) / 5;
				int sides = 4;
				int range = plev / 6 + 2;

				project_length = range;
				if (!get_aim_dir(&dir)) return FALSE;
				fire_bolt(GF_WATER, dir, damroll(dice, sides));
			}
			//ʔw
			else if(command == -2)
			{
				project_length = p_ptr->lev / 12;
				if (!get_aim_dir(&dir)) return FALSE;
				project_hook(GF_ATTACK, dir, HISSATSU_KAPPA, PROJECT_STOP | PROJECT_KILL);
			}
			//荞
			else if(command == -3)
			{
				int y, x, dummy = 0;
				cave_type *c_ptr;
				feature_type *f_ptr = &f_info[cave[py][px].feat];
				/* Only works on adjacent monsters */
				if (!have_flag(f_ptr->flags, FF_WATER))
				{
					msg_print("ɂ͐ȂB");
					return FALSE;
				}
				if (!get_rep_dir(&dir, FALSE)) return FALSE;   /* was get_aim_dir */
				y = py + ddy[dir];
				x = px + ddx[dir];
				c_ptr = &cave[y][x];
				if (!c_ptr->m_idx)
				{
#ifdef JP
					msg_print("ɂ͉ȂB");
#endif
					break;
				}
				else
				{
					monster_type    *m_ptr = &m_list[c_ptr->m_idx];
					monster_race    *r_ptr = &r_info[m_ptr->r_idx];
					char            m_name[80];
					int fail = r_ptr->level;
					if(r_ptr->flags1 & RF1_UNIQUE) fail*=2;
					if(r_ptr->flags2 & RF2_POWERFUL) fail*=2;
					if(r_ptr->flags7 & RF7_CAN_SWIM) fail*=2;
					if(r_ptr->flags7 & RF7_CAN_FLY) fail*=3;
					if(r_ptr->flags2 & RF2_GIGANTIC) fail*=5;
					if(r_ptr->flagsr & RFR_RES_WATE) fail*=5;
					if(r_ptr->flags7 & RF7_AQUATIC) fail*=10;
					fail -= p_ptr->lev + adj_general[p_ptr->stat_ind[A_STR]] * 2;
					if(have_flag(f_ptr->flags, FF_DEEP)) fail /= 2;
					monster_desc(m_name, m_ptr, 0);
					if(fail<0) fail = 0;
					if(randint0(100) < fail)
					{
						msg_format("%s荞ƂsB",m_name);
						break;
					}
					else
					{
						int dam;
						if(!(r_ptr->flags1 & RF1_UNIQUE) && randint1(randint1(r_ptr->level/7)+2) == 1)
						{
							msg_format("%s͐ւƒłEE",m_name);
							dam =  m_ptr->hp + 1;
						}
						else 
						{
							msg_format("%s𐅒ֈ荞񂾁I",m_name);
							dam = plev * 3 + randint1(adj_general[p_ptr->stat_ind[A_STR]] * 4);
						}
						project(0,0,m_ptr->fy,m_ptr->fx,dam,GF_WATER,PROJECT_KILL,-1);
						touch_zap_player(m_ptr);
					}
				}
			}
			break;

			//͒D monster_type.mflagSPECIAL2tOg
		case RACE_MAGICIAN:
		{
			int y, x, dummy = 0;
			cave_type *c_ptr;
			/* Only works on adjacent monsters */
			if (!get_rep_dir(&dir, FALSE)) return FALSE;   /* was get_aim_dir */
			y = py + ddy[dir];
			x = px + ddx[dir];
			c_ptr = &cave[y][x];
			if (!c_ptr->m_idx)
			{
					msg_print("ɂ͉ȂB");
					break;
			}
			else
			{
				//v1.1.27 CV̐\ύX
				monster_type    *m_ptr = &m_list[c_ptr->m_idx];
				monster_race    *r_ptr = &r_info[m_ptr->r_idx];
				char            m_name[80];
				int fail = r_ptr->level;
				if(r_ptr->flags2 & RF2_SMART) fail += r_ptr->level / 2;
				if(r_ptr->flags2 & RF2_POWERFUL) fail += r_ptr->level / 2;
				if(MON_STUNNED(m_ptr)) fail /= 2;
				if(MON_CONFUSED(m_ptr)) fail /= 2;
				if(MON_CSLEEP(m_ptr)) fail = 0;

				monster_desc(m_name, m_ptr, 0);

				if(m_ptr->mflag & MFLAG_SPECIAL2)
				{
					msg_format("%s͂͂DȂ悤B",m_name);
				}
				else if(randint1(fail) > plev)
				{
					msg_format("%s疂͂D̂ɎsB",m_name);
				}
				else
				{
					msg_format("%s疂͂zI",m_name);
					p_ptr->csp += r_ptr->level;
					if (p_ptr->csp >= p_ptr->msp)
					{
						p_ptr->csp = p_ptr->msp;
						p_ptr->csp_frac = 0;
					}
					(void)set_monster_csleep(c_ptr->m_idx, 0);

					if(randint0(100) > r_ptr->level ) m_ptr->mflag |= MFLAG_SPECIAL2;

					p_ptr->redraw |= (PR_MANA);
				}

#if 0 
				monster_type    *m_ptr = &m_list[c_ptr->m_idx];
				monster_race    *r_ptr = &r_info[m_ptr->r_idx];
				char            m_name[80];
				int fail = r_ptr->level + r_ptr->ac / 2;
				if(r_ptr->flags2 & RF2_SMART) fail*=2;
				if(r_ptr->flags1 & RF1_UNIQUE) fail*=2;
				if(r_ptr->flags2 & RF2_STUPID) fail/=2;
				if(r_ptr->flags7 & RF7_CAN_FLY) fail=fail * 3 / 2;
				if(MON_STUNNED(m_ptr)) fail /= 3;
				if(MON_CONFUSED(m_ptr)) fail /= 3;
				if(MON_CSLEEP(m_ptr)) fail = 0;

				fail -= p_ptr->lev + adj_general[p_ptr->stat_ind[A_DEX]] + ref_skill_exp(SKILL_MARTIALARTS) / 200;
				monster_desc(m_name, m_ptr, 0);
				if(fail<0) fail = 0;

				if(m_ptr->mflag & MFLAG_SPECIAL2)
				{
					msg_format("%s͂͂zȂ悤B",m_name);
				}
				else if(randint0(100) < fail)
				{
					msg_format("%sɐG낤Ƃ킳ꂽB",m_name);
					break;
				}
				else
				{
					msg_format("%s疂͂zI",m_name);
					p_ptr->csp += r_ptr->level;
					if (p_ptr->csp >= p_ptr->msp)
					{
						p_ptr->csp = p_ptr->msp;
						p_ptr->csp_frac = 0;
					}
					(void)set_monster_csleep(c_ptr->m_idx, 0);

					if(randint0(100) > r_ptr->level ) m_ptr->mflag |= MFLAG_SPECIAL2;

					touch_zap_player(m_ptr);
					p_ptr->redraw |= (PR_MANA);
				}
#endif
			}
			break;
		}
		case RACE_KARASU_TENGU:
		{
			//ʐ^Be
			if(command == -1)
			{
				if (!get_aim_dir(&dir)) return FALSE;
				project_length = 1;
				fire_beam(GF_PHOTO, dir, 1);
				break;
			}
			//}
			if(command == -2)
			{
				int len=p_ptr->lev / 5;
				if (!rush_attack2(len,0,0)) return FALSE;
				break;
			}
		}
		case RACE_HAKUROU_TENGU:
		{
			//X^[m
			if(command == -1)
			{
				msg_print("Ȃ͂Ǝ𐟂܂...");
				(void)detect_monsters_normal(p_ptr->lev / 2 + 10);
				(void)detect_monsters_invis(p_ptr->lev / 2 + 10);
			}
			//H
			else if(command == -2)
			{
				object_type *q_ptr;
				object_type forge;
				q_ptr = &forge;
				object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_RATION));
#ifdef JP
				msg_print("HƂ𒲒BB");
#endif
				(void)drop_near(q_ptr, -1, py, px);
			}
			//
			else
			{
				probing();
			}
			break;
		}
		case RACE_ONI:
		{
			//m
			if(command == -1)
			{
#ifdef JP
				msg_print("Ȃ͌ɐgCEE");
#endif
				(void)set_afraid(0);
				(void)set_shero(10 + randint1(plev), FALSE);
				(void)hp_player(30);
			}
			//K
			else
			{
				msg_print("Ȃ͑剹I");

				(void)fire_ball(GF_SOUND, 0, p_ptr->lev * 4, 8);
				(void)aggravate_monsters(0,FALSE);
			}
			break;
		}
		case RACE_WARBEAST:
		{
			//X^[m
			if(command == -1)
			{
				msg_print("Ȃ͂Ǝ𐟂܂...");
				(void)detect_monsters_normal(p_ptr->lev / 2 + 10);
				(void)detect_monsters_invis(p_ptr->lev / 2 + 10);
			}
			//m
			else if(command == -2)
			{
#ifdef JP
				msg_print("Ȃ͏b̂悤ɖiI");
#endif
				(void)set_afraid(0);
				(void)set_shero(10 + randint1(plev), FALSE);
				(void)hp_player(30);
			}

			break;
		}
		case RACE_GYOKUTO:
		{
			//\𕷂
			if(command == -1)
			{
				display_rumor_new(0);

			}
			//X^[m
			else if(command == -2)
			{
				msg_print("Ȃ͂Ǝ𐟂܂...");
				(void)detect_monsters_normal(p_ptr->lev / 2 + 10);
				(void)detect_monsters_invis(p_ptr->lev / 2 + 10);
			}
			//V[gEe|[g
			else
			{
#ifdef JP
				msg_print("Ȃ͏uɏB");
#endif
				teleport_player(10, 0L);
			}
			break;
		}
		case RACE_YAMAWARO:

			//ʔw
			project_length = p_ptr->lev / 12;
			if (!get_aim_dir(&dir)) return FALSE;
			project_hook(GF_ATTACK, dir, HISSATSU_KAPPA, PROJECT_STOP | PROJECT_KILL);
			break;
		case RACE_BAKEDANUKI:
		{
			//X^[m
			if(command == -1)
			{
				msg_print("Ȃ͂Ǝ𐟂܂...");
				(void)detect_monsters_normal(p_ptr->lev / 2 + 10);
				(void)detect_monsters_invis(p_ptr->lev / 2 + 10);
			}
			//e|[g
			else if(command == -2)
			{
				msg_print("Ȃ͉ƋɏB");
				teleport_player(p_ptr->lev + 25, 0L);
			}
			else
			{
				if (!(p_ptr->special_defense & NINJA_KAWARIMI))
				{
					msg_print("Ȃ͂Ǝd݂ς܂EE");

					p_ptr->special_defense |= NINJA_KAWARIMI;
					p_ptr->redraw |= (PR_STATUS);
				}
			}
			break;

		}

		case RACE_YOUKO:
		{
			//X^[m
			if(command == -1)
			{
				msg_print("Ȃ͂Ǝ𐟂܂...");
				(void)detect_monsters_normal(p_ptr->lev / 2 + 10);
				(void)detect_monsters_invis(p_ptr->lev / 2 + 10);
			}
			//_U
			else if(command == -2)
			{
			if (!get_aim_dir(&dir)) return FALSE;
#ifdef JP
			msg_print("Ȃ͐_gB");
#else
			msg_print("You concentrate and your eyes glow red...");
#endif

			fire_bolt(GF_PSI, dir, plev * 2);
			}

			//f
			else
			{
				msg_print("Ȃ̖ڂԂP...");
				stun_monsters(plev * 4);
				confuse_monsters(plev * 4);
				turn_monsters(plev * 4);
			}
			break;
		case RACE_HOFGOBLIN:

			{
				object_type *q_ptr;
				object_type forge;
				q_ptr = &forge;
				object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_RATION));
#ifdef JP
				msg_print("HƂ𒲒BB");
#endif
				(void)drop_near(q_ptr, -1, py, px);
			}
			break;

		case RACE_NYUDOU:
		{
			//V[ge|
			if(command == -1)
			{
#ifdef JP
				msg_print("Ȃ͏uɏB");
#endif
				teleport_player(10, 0L);
			}
			//e|obN
			else
			{
				int idx;
				if(!teleport_back(&idx, TELEPORT_FORCE_NEXT)) return FALSE;
			}


			break;
		}
		case RACE_STRAYGOD:
			if(!deity_racial_power_aux(command)) return FALSE;
			break;

		case RACE_FAIRY:
			if(!fairy_racial_power_aux(command)) return FALSE;
			break;

		case RACE_NINJA:
			//XP
			if(command == -1)
			{
				int dice = 2 + (plev) / 6;
				int sides = 5;
				int i;
				int count = (plev) / 5;
				if (!get_aim_dir(&dir)) return FALSE;
				if(count==1) msg_format("XPI");
				else if(count<4) msg_format("%d{̃XPI",count);
				else if(count<6) msg_format("%d{̃XPAIU}GI",count);
				else if(count<9) msg_format("%d{̃XPAI^cWI",count);
				else if(count<11) msg_format("SEKI%d{̃XPAI",count);
				for (i = 0; i < count; i++)
				{
					fire_bolt(GF_WINDCUTTER, dir, damroll(dice, sides));
				}
			}
			//`h[
			else
			{
				bool heal = FALSE;
				msg_print("uXE[bccnA[bccv");
				if(p_ptr->chp < p_ptr->mhp || p_ptr->csp < p_ptr->msp)
					msg_print("ĝɊ͂߂Ă̂B");
				hp_player(randint1(10 + p_ptr->lev/5));
				p_ptr->csp += randint1(5+p_ptr->lev/10);
				if(p_ptr->csp > p_ptr->msp)
				{
					p_ptr->csp = p_ptr->msp;
					p_ptr->csp_frac = 0;
				}
				p_ptr->redraw |= (PR_MANA);
				set_poisoned(p_ptr->poisoned - 10);
				set_stun(p_ptr->stun - 10);
				set_cut(p_ptr->cut - 10);
				set_image(p_ptr->image - 10);

			}
			break;

		case RACE_GOLEM:
			if(!eat_rock()) return FALSE;
			break;

		case RACE_LICH:
		
			if(command == -1)
			{
				int y, x, dummy = 0;
				cave_type *c_ptr;
				/* Only works on adjacent monsters */
				if (!get_rep_dir(&dir, FALSE)) return FALSE;   /* was get_aim_dir */
				y = py + ddy[dir];
				x = px + ddx[dir];
				c_ptr = &cave[y][x];
				if (!c_ptr->m_idx)
				{
						msg_print("ɂ͉ȂB");
				}
				else
				{
					monster_type    *m_ptr = &m_list[c_ptr->m_idx];
					monster_race    *r_ptr = &r_info[m_ptr->r_idx];
					char            m_name[80];
					int fail = r_ptr->level;
					int dam = p_ptr->lev * 2;
						
					monster_desc(m_name, m_ptr, 0);
					if(!monster_living(r_ptr))
					{
						msg_format("%s͐͂Ȃ悤B",m_name);
						break;
					}
					if(r_ptr->flags2 & RF2_POWERFUL) fail*=2;
					if(r_ptr->flags1 & RF1_UNIQUE) fail*=2;
					if(r_ptr->flags7 & RF7_CAN_FLY) fail=fail * 3 / 2;
					fail -= p_ptr->lev ;
					if(fail<0) fail = 0;
					if(randint0(100) < fail)
					{
						msg_format("%sɐG낤Ƃ킳ꂽB",m_name);
						break;
					}
					else
					{
						if(m_ptr->hp +1 < dam) dam = m_ptr->hp +1; 
						msg_format("%sGlM[zI",m_name);
						p_ptr->csp += dam;
						if (p_ptr->csp >= p_ptr->msp)
						{
							p_ptr->csp = p_ptr->msp;
							p_ptr->csp_frac = 0;
						}
						project(0,0,y,x,dam,GF_OLD_DRAIN,PROJECT_HIDE | PROJECT_KILL,-1);
						hp_player(dam);
						touch_zap_player(m_ptr);
						p_ptr->redraw |= (PR_MANA);
					}
				}

			}
			else
			{
				msg_format("׈ȃI[ӂɏ[B");
				dispel_living(plev * 2);
				charm_undead(plev * 2);
			}
			break;

		}
		case RACE_LUNARIAN:

			if(command == -1)//A
			{
				if (!word_of_recall()) return FALSE;
			}
			else//z
			{
				bool flag = FALSE;
				u32b mode = PM_FORCE_PET;
				int r_idx;

				//summon_specificgƍׂ̗̈̋ʓeƉqmoȂ̂r_idxw
				if(randint1(p_ptr->lev) > 44)
				{
					r_idx = MON_MOON_SENTINEL;
					mode |= PM_ALLOW_GROUP;
				}
				else if(randint1(p_ptr->lev) > 39)
				{
					r_idx = MON_GYOKUTO;
					mode |= PM_ALLOW_GROUP;
				}
				else if(randint1(p_ptr->lev) > 34)
					r_idx = MON_MOON_SENTINEL;
				else if(randint1(p_ptr->lev) > 24)
					r_idx = MON_GYOKUTO;
				else 
				{
					if(p_ptr->lev > 34) mode |= PM_ALLOW_GROUP;
					r_idx = MON_EAGLE_RABBIT;
				}

				if (summon_named_creature(0,py,px,r_idx,mode)) flag = TRUE;

				if(flag) msg_print("Ȃ͔zĂяoB");
				else msg_print("NȂB");
			}
		break;

		/*
		case RACE_DWARF:
#ifdef JP
			msg_print("͂𒲂ׂB");
#else
			msg_print("You examine your surroundings.");
#endif

			(void)detect_traps(DETECT_RAD_DEFAULT, TRUE);
			(void)detect_doors(DETECT_RAD_DEFAULT);
			(void)detect_stairs(DETECT_RAD_DEFAULT);
			break;

		*/			
	#if 0
		case RACE_HOBBIT:
			{
				object_type *q_ptr;
				object_type forge;

				/* Get local object */
				q_ptr = &forge;

				/* Create the food ration */
				object_prep(q_ptr, lookup_kind(TV_FOOD, SV_FOOD_RATION));

				/* Drop the object from heaven */
				(void)drop_near(q_ptr, -1, py, px);
#ifdef JP
				msg_print("H𗿗čB");
#else
				msg_print("You cook some food.");
#endif

			}
			break;
#endif
			/*
		case RACE_GNOME:
#ifdef JP
			msg_print("pbI");
#else
			msg_print("Blink!");
#endif

			teleport_player(10, 0L);
			break;
			*/
			/*
		case RACE_HALF_ORC:
#ifdef JP
			msg_print("ECoB");
#else
			msg_print("You play tough.");
#endif

			(void)set_afraid(0);
			break;
			*/
			/*
		case RACE_HALF_TROLL:
#ifdef JP
			msg_print("I");
#else
			msg_print("RAAAGH!");
#endif

			(void)set_afraid(0);
			(void)set_shero(10 + randint1(plev), FALSE);
			(void)hp_player(30);
			break;
			*/
			/*
		case RACE_AMBERITE:
			if (command == -1)
			{
#ifdef JP
				msg_print("Ȃ͕n߂B");
#else
				msg_print("You start walking around. ");
#endif
				alter_reality();
			}
			else if (command == -2)
			{
#ifdef JP
				msg_print("Ȃ́up^[vSɕ`Ă̏...");
#else
				msg_print("You picture the Pattern in your mind and walk it...");
#endif

				(void)set_poisoned(0);
				(void)set_image(0);
				(void)set_stun(0);
				(void)set_cut(0);
				(void)set_blind(0);
				(void)set_afraid(0);
				(void)do_res_stat(A_STR);
				(void)do_res_stat(A_INT);
				(void)do_res_stat(A_WIS);
				(void)do_res_stat(A_DEX);
				(void)do_res_stat(A_CON);
				(void)do_res_stat(A_CHR);
				(void)restore_level();
			}
			break;
		*/
			/*
		case RACE_BARBARIAN:
#ifdef JP
			msg_print("I");
#else
			msg_print("Raaagh!");
#endif

			(void)set_afraid(0);
			(void)set_shero(10 + randint1(plev), FALSE);
			(void)hp_player(30);
			break;
		*/
			/*
		case RACE_HALF_OGRE:
#ifdef JP
			msg_print("̃[TdɎd|...");
#else
			msg_print("You carefully set an explosive rune...");
#endif

			explosive_rune();
			break;

		case RACE_HALF_GIANT:
			if (!get_aim_dir(&dir)) return FALSE;
			(void)wall_to_mud(dir, 20 + randint1(30));
			break;
			*/
/*
		case RACE_HALF_TITAN:
#ifdef JP
			msg_print("G𒲍...");
#else
			msg_print("You examine your foes...");
#endif

			probing();
			break;

		case RACE_CYCLOPS:
			if (!get_aim_dir(&dir)) return FALSE;
#ifdef JP
			msg_print("Ȋ𓊂B");
#else
			msg_print("You throw a huge boulder.");
#endif

			fire_bolt(GF_MISSILE, dir, (3 * plev) / 2);
			break;
*/
/*
		case RACE_YEEK:
			if (!get_aim_dir(&dir)) return FALSE;
			ratial_stop_mouth();
#ifdef JP
			msg_print("g̖т悾ѐグI");
#else
			msg_print("You make a horrible scream!");
#endif

			(void)fear_monster(dir, plev);
			break;
*/
/*
		case RACE_KLACKON:
			if (!get_aim_dir(&dir)) return FALSE;
			ratial_stop_mouth();
#ifdef JP
			msg_print("_fB");
#else
			msg_print("You spit acid.");
#endif

			if (plev < 25) fire_bolt(GF_ACID, dir, plev);
			else fire_ball(GF_ACID, dir, plev, 2);
			break;

		case RACE_KOBOLD:
			if (!get_aim_dir(&dir)) return FALSE;
#ifdef JP
			msg_print("ł̃_[c𓊂B");
#else
			msg_print("You throw a dart of poison.");
#endif

			fire_bolt(GF_POIS, dir, plev);
			break;

		case RACE_NIBELUNG:
#ifdef JP
			msg_print("͂𒲍B");
#else
			msg_print("You examine your surroundings.");
#endif

			(void)detect_traps(DETECT_RAD_DEFAULT, TRUE);
			(void)detect_doors(DETECT_RAD_DEFAULT);
			(void)detect_stairs(DETECT_RAD_DEFAULT);
			break;

		case RACE_DARK_ELF:
			if (!get_aim_dir(&dir)) return FALSE;
#ifdef JP
			msg_print("}WbNE~TCB");
#else
			msg_print("You cast a magic missile.");
#endif

			fire_bolt_or_beam(10, GF_MISSILE, dir,
			    damroll(3 + ((plev - 1) / 5), 4));
			break;
*/
/*
		case RACE_DRACONIAN:
			{
				int  Type = (one_in_(3) ? GF_COLD : GF_FIRE);
#ifdef JP
				cptr Type_desc = ((Type == GF_COLD) ? "C" : "");
#else
				cptr Type_desc = ((Type == GF_COLD) ? "cold" : "fire");
#endif

				if (!get_aim_dir(&dir)) return FALSE;

				if (randint1(100) < plev)
				{
					switch (p_ptr->pclass)
					{
						case CLASS_WARRIOR:
						case CLASS_BERSERKER:
						case CLASS_RANGER:
						case CLASS_TOURIST:
						case CLASS_IMITATOR:
						case CLASS_ARCHER:
						case CLASS_SMITH:
							if (one_in_(3))
							{
								Type = GF_MISSILE;
#ifdef JP
								Type_desc = "Gg";
#else
								Type_desc = "the elements";
#endif
							}
							else
							{
								Type = GF_SHARDS;
#ifdef JP
								Type_desc = "j";
#else
								Type_desc = "shards";
#endif
							}
							break;
						case CLASS_MAGE:
						case CLASS_WARRIOR_MAGE:
						case CLASS_HIGH_MAGE:
						case CLASS_SORCERER:
						case CLASS_MAGIC_EATER:
						case CLASS_RED_MAGE:
						case CLASS_BLUE_MAGE:
						case CLASS_MIRROR_MASTER:
							if (one_in_(3))
							{
								Type = GF_MANA;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "mana";
#endif
							}
							else
							{
								Type = GF_DISENCHANT;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "disenchantment";
#endif
							}
							break;
						case CLASS_CHAOS_WARRIOR:
							if (!one_in_(3))
							{
								Type = GF_CONFUSION;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "confusion";
#endif
							}
							else
							{
								Type = GF_CHAOS;
#ifdef JP
								Type_desc = "JIX";
#else
								Type_desc = "chaos";
#endif
							}
							break;
						case CLASS_MONK:
						case CLASS_SAMURAI:
						case CLASS_FORCETRAINER:
							if (!one_in_(3))
							{
								Type = GF_CONFUSION;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "confusion";
#endif
							}
							else
							{
								Type = GF_SOUND;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "sound";
#endif
							}
							break;
						case CLASS_MINDCRAFTER:
							if (!one_in_(3))
							{
								Type = GF_CONFUSION;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "confusion";
#endif
							}
							else
							{
								Type = GF_PSI;
#ifdef JP
								Type_desc = "_GlM[";
#else
								Type_desc = "mental energy";
#endif
							}
							break;
						case CLASS_PRIEST:
						case CLASS_PALADIN:
							if (one_in_(3))
							{
								Type = GF_HELL_FIRE;
#ifdef JP
								Type_desc = "n̍";
#else
								Type_desc = "hellfire";
#endif
							}
							else
							{
								Type = GF_HOLY_FIRE;
#ifdef JP
								Type_desc = "Ȃ鉊";
#else
								Type_desc = "holy fire";
#endif
							}
							break;
						case CLASS_ROGUE:
						case CLASS_NINJA:
							if (one_in_(3))
							{
								Type = GF_DARK;
#ifdef JP
								Type_desc = "Í";
#else
								Type_desc = "darkness";
#endif
							}
							else
							{
								Type = GF_POIS;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "poison";
#endif
							}
							break;
						case CLASS_BARD:
							if (!one_in_(3))
							{
								Type = GF_SOUND;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "sound";
#endif
							}
							else
							{
								Type = GF_CONFUSION;
#ifdef JP
								Type_desc = "";
#else
								Type_desc = "confusion";
#endif
							}
							break;
					}
				}

				ratial_stop_mouth();

#ifdef JP
				msg_format("Ȃ%s̃uXfB", Type_desc);
#else
				msg_format("You breathe %s.", Type_desc);
#endif

				fire_ball(Type, dir, plev * 2,
				    -(plev / 15) - 1);
			}
			break;

		case RACE_MIND_FLAYER:
			if (!get_aim_dir(&dir)) return FALSE;
#ifdef JP
			msg_print("Ȃ͏WAڂԂP...");
#else
			msg_print("You concentrate and your eyes glow red...");
#endif

			fire_bolt(GF_PSI, dir, plev);
			break;

		case RACE_IMP:
			if (!get_aim_dir(&dir)) return FALSE;
			if (plev >= 30)
			{
#ifdef JP
				msg_print("t@CAE{[B");
#else
				msg_print("You cast a ball of fire.");
#endif

				fire_ball(GF_FIRE, dir, plev, 2);
			}
			else
			{
#ifdef JP
				msg_print("t@CAE{gB");
#else
				msg_print("You cast a bolt of fire.");
#endif

				fire_bolt(GF_FIRE, dir, plev);
			}
			break;

		case RACE_GOLEM:
			(void)set_shield(randint1(20) + 30, FALSE);
			break;
*/
/*
		case RACE_SKELETON:
		case RACE_ZOMBIE:
#ifdef JP
			msg_print("Ȃ͎GlM[߂Ǝ݂B");
#else
			msg_print("You attempt to restore your lost energies.");
#endif

			(void)restore_level();
			break;
*/

		case RACE_VAMPIRE:
			if (d_info[dungeon_type].flags1 & DF1_NO_MELEE)
			{
#ifdef JP
				msg_print("ȂU邱ƂłȂB");
#else
				msg_print("Something prevent you from attacking.");
#endif
				return FALSE;
			}
			else
			{
				int y, x, dummy = 0;
				cave_type *c_ptr;

				/* Only works on adjacent monsters */
				if (!get_rep_dir(&dir,FALSE)) return FALSE;   /* was get_aim_dir */
				y = py + ddy[dir];
				x = px + ddx[dir];
				c_ptr = &cave[y][x];

				ratial_stop_mouth();

				if (!c_ptr->m_idx)
				{
#ifdef JP
					msg_print("ȂꏊɊ݂I");
#else
					msg_print("You bite into thin air!");
#endif

					break;
				}

#ifdef JP
				msg_print("Ȃ̓jƂĉނ...");
#else
				msg_print("You grin and bare your fangs...");
#endif

				dummy = plev + randint1(plev) * MAX(1, plev / 10);   /* Dmg */
				if (drain_life(dir, dummy))
				{
					if (p_ptr->food < PY_FOOD_FULL)
						/* No heal if we are "full" */
						(void)hp_player(dummy);
					else
#ifdef JP
						msg_print("Ȃ͋󕠂ł͂܂B");
#else
						msg_print("You were not hungry.");
#endif

					/* Gain nutritional sustenance: 150/hp drained */
					/* A Food ration gives 5000 food points (by contrast) */
					/* Don't ever get more than "Full" this way */
					/* But if we ARE Gorged,  it won't cure us */
					dummy = p_ptr->food + MIN(5000, 100 * dummy);
					if (p_ptr->food < PY_FOOD_MAX)   /* Not gorged already */
						(void)set_food(dummy >= PY_FOOD_MAX ? PY_FOOD_MAX - 1 : dummy);
				}
				else
#ifdef JP
					msg_print("BЂǂB");
#else
					msg_print("Yechh. That tastes foul.");
#endif

			}
			break;
/*
		case RACE_SPECTRE:
			if (!get_aim_dir(&dir)) return FALSE;
			ratial_stop_mouth();
#ifdef JP
			msg_print("Ȃ͂ǂ남ǂ낵ѐI");
#else
			msg_print("You emit an eldritch howl!");
#endif

			(void)fear_monster(dir, plev);
			break;
*/
		/*
		case RACE_SPRITE:
#ifdef JP
			msg_print("Ȃ͖@̕𓊂...");
#else
			msg_print("You throw some magic dust...");
#endif

			if (plev < 25) sleep_monsters_touch();
			else (void)sleep_monsters(plev);
			break;
*/
			/*
		case RACE_DEMON:
			{
				int type = (one_in_(2) ? GF_NETHER : GF_FIRE);
				if (!get_aim_dir(&dir)) return FALSE;
				ratial_stop_mouth();
#ifdef JP
				msg_format("Ȃ%s̃uXfB",((type == GF_NETHER) ? "n" : "Ή"));
#else
				msg_format("You breathe %s.",((type == GF_NETHER) ? "nether" : "fire"));
#endif

				fire_ball(type, dir, plev * 3, -(plev / 15) - 1);
			}
			break;
		case RACE_KUTAR:
			(void)set_tsubureru(randint1(20) + 30, FALSE);
			break;
		case RACE_ANDROID:
			if (!get_aim_dir(&dir)) return FALSE;
			if (plev < 10)
			{
#ifdef JP
				msg_print("CK𔭎˂B");
#else
				msg_print("You fire your ray gun.");
#endif
				fire_bolt(GF_MISSILE, dir, (plev+1) / 2);
			}
			else if (plev < 25)
			{
#ifdef JP
				msg_print("uX^[𔭎˂B");
#else
				msg_print("You fire your blaster.");
#endif
				fire_bolt(GF_MISSILE, dir, plev);
			}
			else if (plev < 35)
			{
#ifdef JP
				msg_print("oY[J𔭎˂B");
#else
				msg_print("You fire your bazooka.");
#endif
				fire_ball(GF_MISSILE, dir, plev * 2, 2);
			}
			else if (plev < 45)
			{
#ifdef JP
				msg_print("r[Lm𔭎˂B");
#else
				msg_print("You fire a beam cannon.");
#endif
				fire_beam(GF_MISSILE, dir, plev * 2);
			}
			else
			{
#ifdef JP
				msg_print("Pbg𔭎˂B");
#else
				msg_print("You fire a rocket.");
#endif
				fire_rocket(GF_ROCKET, dir, plev * 5, 2);
			}
			break;
*/
		default:
#ifdef JP
			msg_print("̎푰͓Ȕ\͂Ă܂B");
#else
			msg_print("This race has no bonus power.");
#endif

			energy_use = 0;
	}
	}







	return TRUE;
}


/*
 * Allow user to choose a power (racial / mutation) to activate
 */
/*:::CVp[gp*/
///mod140226 info\ǉ
void do_cmd_racial_power(bool only_info)
{
	power_desc_type power_desc[36];
	int             num, i = 0;
	int             ask = TRUE;
	int             lvl = p_ptr->lev;
	bool            flag, redraw, cast = FALSE;
	///class mAm̓ꃌCV
	bool            warrior = ((p_ptr->pclass == CLASS_WARRIOR/* || p_ptr->pclass == CLASS_BERSERKER*/) ? TRUE : FALSE);
	char            choice;
	char            out_val[160];
	int menu_line = (use_menu ? 1 : 0);

	if(SAKUYA_WORLD)
	{
		msg_print("͂̔\͂gȂB");
		return;
	}

	for (num = 0; num < 36; num++)
	{
		strcpy(power_desc[num].name, "");
		power_desc[num].number = 0;
	}

	num = 0;

	if (p_ptr->confused)
	{
#ifdef JP
msg_print("Ăē\͂g܂I");
#else
		msg_print("You are too confused to use any powers!");
#endif

		energy_use = 0;
		return;
	}

	if (p_ptr->special_defense & (KATA_MUSOU | KATA_KOUKIJIN))
	{
		set_action(ACTION_NONE);
	}

	//iC@A
	if(p_ptr->pseikaku == SEIKAKU_BERSERK)
	{
		strcpy(power_desc[num].name, "A");

		power_desc[num].level = 10;
		power_desc[num].cost = 10;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 12;
		power_desc[num].info = "nƃ_WsB";
		power_desc[num++].number = -105;
	}
	//Extra[h̃ACeJ[hiiCł͎gȂj
	else if(EXTRA_MODE && !(mimic_info[p_ptr->mimic_form].MIMIC_FLAGS & (MIMIC_NO_MAGICITEM)))
	{
			strcpy(power_desc[num].name, "ACeJ[hZbg");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 0;
			power_desc[num].info = "uACeJ[hvJ[hXbg8ނ܂Ŋi[B";
			power_desc[num++].number = -101;

			strcpy(power_desc[num].name, "ACeJ[hg");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 0;
			power_desc[num].info = "ZbguACeJ[hvgpBgꖇB";
			power_desc[num++].number = -102;

			strcpy(power_desc[num].name, "ACeJ[h");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 0;
			power_desc[num].info = "ZbguACeJ[hvJ[hXbgoB";
			power_desc[num++].number = -103;

			strcpy(power_desc[num].name, "ACeJ[hǂ");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 0;
			power_desc[num].info = "ZbguACeJ[hvɏꂽǂށB";
			power_desc[num++].number = -104;
	}


	///class EƂƃCVp[
	///del140202 EƃCVSĔp~ JR}hɈڍs
#if 0
	switch (p_ptr->pclass)
	{
	case CLASS_WARRIOR:
	{
#ifdef JP
strcpy(power_desc[num].name, "̕");
#else
		strcpy(power_desc[num].name, "Sword Dancing");
#endif

		power_desc[num].level = 40;
		power_desc[num].cost = 75;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 35;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_HIGH_MAGE:
	if (p_ptr->realm1 == REALM_HEX)
	{
#ifdef JP
		strcpy(power_desc[num].name, "r߂");
#else
		strcpy(power_desc[num].name, "Stop spelling");
#endif
		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_MAGE:
	/* case CLASS_HIGH_MAGE: */
	case CLASS_SORCERER:
	{
#ifdef JP
strcpy(power_desc[num].name, "͐H");
#else
		strcpy(power_desc[num].name, "Eat Magic");
#endif

		power_desc[num].level = 25;
		power_desc[num].cost = 1;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 25;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_PRIEST:
	{
		if (is_good_realm(p_ptr->realm1))
		{
#ifdef JP
strcpy(power_desc[num].name, "j");
#else
			strcpy(power_desc[num].name, "Bless Weapon");
#endif

			power_desc[num].level = 35;
			power_desc[num].cost = 70;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 50;
			power_desc[num++].number = -3;
		}
		else
		{
#ifdef JP
strcpy(power_desc[num].name, "");
#else
			strcpy(power_desc[num].name, "Evocation");
#endif

			power_desc[num].level = 42;
			power_desc[num].cost = 40;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 35;
			power_desc[num++].number = -3;
		}
		break;
	}
	case CLASS_ROGUE:
	{
#ifdef JP
strcpy(power_desc[num].name, "qbgAEFC");
#else
		strcpy(power_desc[num].name, "Hit and Away");
#endif

		power_desc[num].level = 8;
		power_desc[num].cost = 12;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 14;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_RANGER:
	case CLASS_SNIPER:
	{
#ifdef JP
strcpy(power_desc[num].name, "X^[");
#else
		strcpy(power_desc[num].name, "Probe Monster");
#endif

		power_desc[num].level = 15;
		power_desc[num].cost = 20;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 12;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_PALADIN:
	{
		if (is_good_realm(p_ptr->realm1))
		{
#ifdef JP
strcpy(power_desc[num].name, "z[[EX");
#else
			strcpy(power_desc[num].name, "Holy Lance");
#endif

			power_desc[num].level = 30;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 30;
			power_desc[num++].number = -3;
		}
		else
		{
#ifdef JP
strcpy(power_desc[num].name, "wEX");
#else
			strcpy(power_desc[num].name, "Hell Lance");
#endif

			power_desc[num].level = 30;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 30;
			power_desc[num++].number = -3;
		}
		break;
	}
	case CLASS_WARRIOR_MAGE:
	{
#ifdef JP
strcpy(power_desc[num].name, "ϊ: golo");
#else
		strcpy(power_desc[num].name, "Convert HP to SP");
#endif

		power_desc[num].level = 25;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 10;
		power_desc[num++].number = -3;
#ifdef JP
strcpy(power_desc[num].name, "ϊ: logo");
#else
		strcpy(power_desc[num].name, "Convert SP to HP");
#endif

		power_desc[num].level = 25;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 10;
		power_desc[num++].number = -4;
		break;
	}
	case CLASS_CHAOS_WARRIOR:
	{
#ifdef JP
strcpy(power_desc[num].name, "f̌");
#else
		strcpy(power_desc[num].name, "Confusing Light");
#endif

		power_desc[num].level = 40;
		power_desc[num].cost = 50;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 25;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_MONK:
	{
#ifdef JP
strcpy(power_desc[num].name, "\");
#else
		strcpy(power_desc[num].name, "Assume a Posture");
#endif

		power_desc[num].level = 25;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
#ifdef JP
strcpy(power_desc[num].name, "S");
#else
		strcpy(power_desc[num].name, "Double Attack");
#endif

		power_desc[num].level = 30;
		power_desc[num].cost = 30;
		power_desc[num].stat = A_STR;
		power_desc[num].fail = 20;
		power_desc[num++].number = -4;
		break;
	}
	case CLASS_MINDCRAFTER:
	case CLASS_FORCETRAINER:
	{
#ifdef JP
strcpy(power_desc[num].name, "~");
#else
		strcpy(power_desc[num].name, "Clear Mind");
#endif

		power_desc[num].level = 15;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_WIS;
		power_desc[num].fail = 10;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_TOURIST:
	{
#ifdef JP
strcpy(power_desc[num].name, "ʐ^Be");
#else
		strcpy(power_desc[num].name, "Take a Photograph");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
#ifdef JP
strcpy(power_desc[num].name, "^EӒ");
#else
		strcpy(power_desc[num].name, "Identify True");
#endif

		power_desc[num].level = 25;
		power_desc[num].cost = 20;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 20;
		power_desc[num++].number = -4;
		break;
	}
	case CLASS_IMITATOR:
	{
#ifdef JP
strcpy(power_desc[num].name, "{Ԃ");
#else
		strcpy(power_desc[num].name, "Double Revenge");
#endif

		power_desc[num].level = 30;
		power_desc[num].cost = 100;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 30;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_BEASTMASTER:
	{
#ifdef JP
strcpy(power_desc[num].name, "xz");
#else
		strcpy(power_desc[num].name, "Dominate a Living Thing");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = (p_ptr->lev+3)/4;
		power_desc[num].stat = A_CHR;
		power_desc[num].fail = 10;
		power_desc[num++].number = -3;
#ifdef JP
strcpy(power_desc[num].name, "^Exz");
#else
		strcpy(power_desc[num].name, "Dominate Living Things");
#endif

		power_desc[num].level = 30;
		power_desc[num].cost = (p_ptr->lev+20)/2;
		power_desc[num].stat = A_CHR;
		power_desc[num].fail = 10;
		power_desc[num++].number = -4;
		break;
	}
	case CLASS_ARCHER:
	{
#ifdef JP
strcpy(power_desc[num].name, "e/̐");
#else
		strcpy(power_desc[num].name, "Create Ammo");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_MAGIC_EATER:
	{
#ifdef JP
strcpy(power_desc[num].name, "͂̎荞");
#else
		strcpy(power_desc[num].name, "Absorb Magic");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;

		strcpy(power_desc[num].name, _("͔", "Powerful Activation"));
		power_desc[num].level = 10;
		power_desc[num].cost = 10 + (lvl - 10) / 2;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 0;
		power_desc[num++].number = -4;
		break;
	}
	case CLASS_BARD:
	{
#ifdef JP
strcpy(power_desc[num].name, "̂~߂");
#else
		strcpy(power_desc[num].name, "Stop Singing");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_CHR;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_RED_MAGE:
	{
#ifdef JP
strcpy(power_desc[num].name, "A");
#else
		strcpy(power_desc[num].name, "Double Magic");
#endif

		power_desc[num].level = 48;
		power_desc[num].cost = 20;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_SAMURAI:
	{
#ifdef JP
strcpy(power_desc[num].name, "C");
#else
		strcpy(power_desc[num].name, "Concentration");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_WIS;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
#ifdef JP
strcpy(power_desc[num].name, "^");
#else
		strcpy(power_desc[num].name, "Assume a Posture");
#endif

		power_desc[num].level = 25;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 0;
		power_desc[num++].number = -4;
		break;
	}
	case CLASS_BLUE_MAGE:
	{
#ifdef JP
strcpy(power_desc[num].name, "[jO");
#else
		strcpy(power_desc[num].name, "Learning");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_CAVALRY:
	{
#ifdef JP
strcpy(power_desc[num].name, "rnȂ炵");
#else
		strcpy(power_desc[num].name, "Rodeo");
#endif

		power_desc[num].level = 10;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_STR;
		power_desc[num].fail = 10;
		power_desc[num++].number = -3;
		break;
	}
/*
	case CLASS_BERSERKER:
	{
#ifdef JP
strcpy(power_desc[num].name, "A");
#else
		strcpy(power_desc[num].name, "Recall");
#endif

		power_desc[num].level = 10;
		power_desc[num].cost = 10;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 20;
		power_desc[num++].number = -3;
		break;
	}
*/
	case CLASS_MIRROR_MASTER:
	{
#ifdef JP
strcpy(power_desc[num].name, "");
#else
		strcpy(power_desc[num].name, "Break Mirrors");
#endif

		power_desc[num].level = 1;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
#ifdef JP
strcpy(power_desc[num].name, "Ð");
#else
		strcpy(power_desc[num].name, "Mirror Concentration");
#endif

		power_desc[num].level = 30;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 20;
		power_desc[num++].number = -4;
		break;
	}
	case CLASS_SMITH:
	{
#ifdef JP
strcpy(power_desc[num].name, "ڗ");
#else
		strcpy(power_desc[num].name, "Judgment");
#endif

		power_desc[num].level = 5;
		power_desc[num].cost = 15;
		power_desc[num].stat = A_INT;
		power_desc[num].fail = 20;
		power_desc[num++].number = -3;
		break;
	}
	case CLASS_NINJA:
	{
#ifdef JP
strcpy(power_desc[num].name, "삯");
#else
		strcpy(power_desc[num].name, "Quick Walk");
#endif

		power_desc[num].level = 20;
		power_desc[num].cost = 0;
		power_desc[num].stat = A_DEX;
		power_desc[num].fail = 0;
		power_desc[num++].number = -3;
		break;
	}
	default:
#ifdef JP
strcpy(power_desc[0].name, "(Ȃ)");
#else
		strcpy(power_desc[0].name, "(none)");
#endif

	}
#endif
	///magic ϐg̃CV
	if (p_ptr->mimic_form)
	{
		switch (p_ptr->mimic_form)
		{
		case MIMIC_DEMON:
		case MIMIC_DEMON_LORD:
#ifdef JP
sprintf(power_desc[num].name, "n/Ή̃uX (_[W %d)", lvl * 3);
#else
			sprintf(power_desc[num].name, "Nether or Fire Breath (dam %d)", lvl * 3);
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 10+lvl/3;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 20;
			power_desc[num].info = "Ήn̂ǂ炩̑̃uXfB";
			power_desc[num++].number = -1;
			break;
		case MIMIC_VAMPIRE:
#ifdef JP
strcpy(power_desc[num].name, "z̉");
#else
			strcpy(power_desc[num].name, "Drain Life");
#endif

			power_desc[num].level = 1;
			power_desc[num].cost = 1 + (lvl / 3);
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 9;
			power_desc[num].info = "GɊݕtČzA̗͂zĖx񕜂B";
			power_desc[num++].number = -1;
			break;
		case MIMIC_GIGANTIC:
		case MIMIC_SHINMYOU:
#ifdef JP
strcpy(power_desc[num].name, "̑傫ɖ߂");
#else
			strcpy(power_desc[num].name, "Drain Life");
#endif

			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 0;
			power_desc[num].info = "̑傫ɖ߂B";
			power_desc[num++].number = -1;
			break;

		case MIMIC_BEAST:
			strcpy(power_desc[num].name, "̎pɖ߂");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 0;
			power_desc[num].info = "̎pɖ߂B";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "K");
			power_desc[num].level = 20;
			power_desc[num].cost = 20;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 5;
			power_desc[num].info = "̏ŖiBE̓G|AĎ͋mB͂̐QĂGNB";
			power_desc[num++].number = -2;

			strcpy(power_desc[num].name, "ːi");
			power_desc[num].level = 30;
			power_desc[num].cost = 50;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 30;
			power_desc[num].info = "wʒu܂ōő5Obhi݁A̓rɂGɃ_[W(x*4)^΂BNs\n`⋐ȓGɓƎ~܂B";
			power_desc[num++].number = -3;

			break;
		case MIMIC_SLIME:
			strcpy(power_desc[num].name, "̎pɖ߂");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 0;
			power_desc[num].info = "̎pɖ߂B";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "_̃uX");
			power_desc[num].level = 40;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 30;
			power_desc[num].info = "ݑ̗͂1/3_[W̎_̃uXfB";
			power_desc[num++].number = -2;

			break;


		case MIMIC_MARISA:
			strcpy(power_desc[num].name, "̎pɖ߂");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 0;
			power_desc[num].info = "̎pɖ߂B";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "}X^[Xp[N(U)");
			power_desc[num].level = 24;
			power_desc[num].cost = 36;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 30;
			power_desc[num].info = "x*3̈З͂̊jM̃[U[B";
			power_desc[num++].number = -2;

			strcpy(power_desc[num].name, "EBb`CC(U)");
			power_desc[num].level = 30;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 20;
			power_desc[num].info = "ⴂɌׂēˌBGɂԂƃx*2̖̃_[W^B";
			power_desc[num++].number = -3;

			strcpy(power_desc[num].name, "t@CiXp[N(U)");
			power_desc[num].level = 40;
			power_desc[num].cost = 60;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 50;
			power_desc[num].info = "x*7̈З͂̕𑮐̑^[U[B";
			power_desc[num++].number = -4;
			break;

		case MIMIC_MIST:
			strcpy(power_desc[num].name, "̎pɖ߂");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 0;
			power_desc[num].info = "̎pɖ߂B";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "ړ");
			power_desc[num].level = 30;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 20;
			power_desc[num].info = "ɂȂĎE̔Cӂ̏ꏊɈړBRXgs͂{B";
			power_desc[num++].number = -2;
			break;

		case MIMIC_DRAGON:
		{
			int rank = p_ptr->mimic_dragon_rank;
			strcpy(power_desc[num].name, "̎pɖ߂");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 0;
			power_desc[num].info = "̎pɖ߂B";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "Ή̃uX");
			power_desc[num].level = 30;
			power_desc[num].cost = 50;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 25;
			power_desc[num].info = "HP1/3(ő1600)̈З͂̉Ή̃uXfB";
			power_desc[num++].number = -2;

			if(rank > 119)
			{
				strcpy(power_desc[num].name, "vY}̃uX");
				power_desc[num].level = 35;
				power_desc[num].cost = 70;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 30;
				power_desc[num].info = "HP1/4(ő1200)̈З͂̃vY}̃uXfB";
				power_desc[num++].number = -3;
			}

			if(rank > 124)
			{
				strcpy(power_desc[num].name, "jM̃uX");
				power_desc[num].level = 40;
				power_desc[num].cost = 80;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 35;
				power_desc[num].info = "HP1/4(ő1000)̈З͂̊jM̃uXfB";
				power_desc[num++].number = -4;
			}
			if(rank > 129)
			{
				strcpy(power_desc[num].name, "Ռg̃uX");
				power_desc[num].level = 45;
				power_desc[num].cost = 100;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 35;
				power_desc[num].info = "HP1/6(ő450)̈З͂̏Ռg̃uXfB";
				power_desc[num++].number = -5;
			}
			if(rank > 134)
			{
				strcpy(power_desc[num].name, "JIX̃uX");
				power_desc[num].level = 45;
				power_desc[num].cost = 130;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 35;
				power_desc[num].info = "HP1/6(ő600)̈З͂̃JIX̃uXfB";
				power_desc[num++].number = -6;
			}
			if(rank > 139)
			{
				strcpy(power_desc[num].name, "ʍ̃uX");
				power_desc[num].level = 48;
				power_desc[num].cost = 160;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 40;
				power_desc[num].info = "HP1/7(ő600)̈З͂̈ʍ̃uXfBϐŒRB";
				power_desc[num++].number = -7;
			}
			if(rank > 149)
			{
				strcpy(power_desc[num].name, "gC");
				power_desc[num].level = 50;
				power_desc[num].cost = 200;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 45;
				power_desc[num].info = "HP1/6(ő555)̈З͂̕𑮐̋ȃ[U[B";
				power_desc[num++].number = -8;
			}
			if(rank > 154)
			{
				strcpy(power_desc[num].name, "d̃uX");
				power_desc[num].level = 30;
				power_desc[num].cost = 50;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 25;
				power_desc[num].info = "HP1/3(ő1600)̈З͂̓d̃uXfB";
				power_desc[num++].number = -9;
			}
			if(rank > 159)
			{
				strcpy(power_desc[num].name, "C̃uX");
				power_desc[num].level = 30;
				power_desc[num].cost = 50;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 25;
				power_desc[num].info = "HP1/3(ő1600)̈З̗͂C̃uXfB";
				power_desc[num++].number = -10;
			}
			if(rank > 164)
			{
				strcpy(power_desc[num].name, "_̃uX");
				power_desc[num].level = 30;
				power_desc[num].cost = 50;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 25;
				power_desc[num].info = "HP1/3(ő1600)̈З͂̎_̃uXfB";
				power_desc[num++].number = -11;
			}

			if(rank > 169)
			{
				strcpy(power_desc[num].name, "̔");
				power_desc[num].level = 50;
				power_desc[num].cost = 100;
				power_desc[num].stat = A_INT;
				power_desc[num].fail = 50;
				power_desc[num].info = "ꏊw肵ăe|[gB";
				power_desc[num++].number = -12;
			}


			break;
		}
		case MIMIC_CAT:
			strcpy(power_desc[num].name, "l^ɂȂ");
			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 0;
			power_desc[num].info = "̎pɖ߂B";
			power_desc[num++].number = -1;
			break;


		case MIMIC_NUE:
		{
			strcpy(power_desc[num].name, "V[gEe|[g");
			power_desc[num].level = 1;
			power_desc[num].cost = 3;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 5;
			power_desc[num].info = "10̃e|[gB";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "K̖");
			power_desc[num].level = 7;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 5;
			power_desc[num].info = "E̓G|AB";
			power_desc[num++].number = -2;

			strcpy(power_desc[num].name, "KX̃uX");
			power_desc[num].level = 15;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 15;
			power_desc[num].info = "HP1/5(ő300)̈З͂̓ł̃uXfB";
			power_desc[num++].number = -3;

			strcpy(power_desc[num].name, "");
			power_desc[num].level = 24;
			power_desc[num].cost = 16;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 20;
			power_desc[num].info = "w肵ꏊɈЗ(x*5)̗𗎂ƂB";
			power_desc[num++].number = -4;

			strcpy(power_desc[num].name, "Í̃uX");
			power_desc[num].level = 32;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 30;
			power_desc[num].info = "HP1/4(ő400)̈З͂̈Í̃uXfB";
			power_desc[num++].number = -5;

			strcpy(power_desc[num].name, "JIX̃uX");
			power_desc[num].level = 40;
			power_desc[num].cost = 50;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 40;
			power_desc[num].info = "HP1/3(ő600)̈З͂̃JIX̃uXfB";
			power_desc[num++].number = -6;

			break;
			}

		//h~[ϐgȂ
		case MIMIC_METAMORPHOSE_NORMAL:
		case MIMIC_METAMORPHOSE_MONST:
		case MIMIC_METAMORPHOSE_GIGANTIC:
			{

				strcpy(power_desc[num].name, "̎pɂĒׂ");
				power_desc[num].level = 1;
				power_desc[num].cost = 0;
				power_desc[num].stat = A_INT;
				power_desc[num].fail = 0;
				power_desc[num].info = "ϐg̃X^[̏𓾂B";
				power_desc[num++].number = -1;

				strcpy(power_desc[num].name, "̎pɖ߂");
				power_desc[num].level = 1;
				power_desc[num].cost = 0;
				power_desc[num].stat = A_CON;
				power_desc[num].fail = 0;
				power_desc[num].info = "̎pɖ߂B";
				power_desc[num++].number = -2;

				strcpy(power_desc[num].name, "Z");
				power_desc[num].level = 1;
				power_desc[num].cost = 0;
				power_desc[num].stat = A_DEX;
				power_desc[num].fail = 0;
				power_desc[num].info = "ϐg̃X^[̓ZgBZ̎ނɂďMP␬ωB";
				power_desc[num++].number = -3;


			}
			break;

		}

	}
	else
	{
	///race 푰ƃCV
	switch (p_ptr->prace)
	{

		case RACE_SENNIN:
#ifdef JP
strcpy(power_desc[num].name, "~");
#endif

			power_desc[num].level = 30;
			power_desc[num].cost = 1;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 20;
			power_desc[num].info = "_܂AMP킸ɉ񕜂B";
			power_desc[num++].number = -1;
			break;
		case RACE_TENNIN:
#ifdef JP
strcpy(power_desc[num].name, "~");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 1;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 18;
			power_desc[num].info = "_܂AMP킸ɉ񕜂B";
			power_desc[num++].number = -1;
			break;

		case RACE_KAPPA:
#ifdef JP
strcpy(power_desc[num].name, "SC");
#endif

			power_desc[num].level = 12;
			power_desc[num].cost = 7;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 10;
			power_desc[num].info = "(3+x/5)d4̈З͂̐{gB";
			power_desc[num++].number = -1;

#ifdef JP
strcpy(power_desc[num].name, "ʔw");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 10;
			power_desc[num].info = "ꂽƂɂ郂X^[UBɉčU񐔂B";
			power_desc[num++].number = -2;
#ifdef JP
strcpy(power_desc[num].name, "荞");
#endif

			power_desc[num].level = 35;
			power_desc[num].cost = 24;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 30;
			power_desc[num].info = "אڂG𐅒Ɉ荞ށBɂȂƎgȂBȓGłGɂ͌ɂB";
			power_desc[num++].number = -3;


			break;
		case RACE_MAGICIAN:
#ifdef JP
strcpy(power_desc[num].name, "͒D");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 1;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 30;
			power_desc[num].info = "אڂX^[̂疂͂DBxȓG͋Gɂ͌ɂB";
			power_desc[num++].number = -1;
			break;

		case RACE_KARASU_TENGU:
#ifdef JP
strcpy(power_desc[num].name, "ʐ^Be");
#endif

			power_desc[num].level = 1;
			power_desc[num].cost = 0;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 0;
			power_desc[num].info = "אڂ^[Qbg̎ʐ^BeB";
			power_desc[num++].number = -1;
#ifdef JP
strcpy(power_desc[num].name, "}");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = 16;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 36;
			power_desc[num].info = "(x/5)̎E̎w肵ʒuֈuňړBGEXEǂȂǂɎՂƂŎ~܂B";
			power_desc[num++].number = -2;
			break;



		case RACE_HAKUROU_TENGU:
#ifdef JP
strcpy(power_desc[num].name, "X^[m");
#endif

			power_desc[num].level = 3;
			power_desc[num].cost = 3;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 10;
			power_desc[num].info = "a(x/2+10)܂ł̃X^[̋Cz@mB";
			power_desc[num++].number = -1;

#ifdef JP
strcpy(power_desc[num].name, "HƐ");
#endif
			power_desc[num].level = 15;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 10;
			power_desc[num].info = "͂̐ĤׂTČgѐHɎdグB";
			power_desc[num++].number = -2;
#ifdef JP
strcpy(power_desc[num].name, "X^[");
#else
			strcpy(power_desc[num].name, "Probing");
#endif

			power_desc[num].level = 30;
			power_desc[num].cost = 20;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 20;
			power_desc[num].info = "ẼX^[̏ڍׂȏ𓾂B";
			power_desc[num++].number = -3;
			break;

		case RACE_ONI:

#ifdef JP
			strcpy(power_desc[num].name, "m");
#endif

			power_desc[num].level = 12;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 10;
			power_desc[num].info = "ŠJAmԂɂȂB";
			power_desc[num++].number = -1;

#ifdef JP
			strcpy(power_desc[num].name, "K");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 20;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 20;
			power_desc[num].info = "ӂ剹ōUB͂̓GNB";
			power_desc[num++].number = -2;


			break;
		case RACE_WARBEAST:
			if(p_ptr->pclass != CLASS_KEINE ) //d̓X^[mgȂ
			{

			strcpy(power_desc[num].name, "X^[m");
			power_desc[num].level = 3;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num].info = "a(x/2+10)܂ł̃X^[̋Cz@mB";
			power_desc[num++].number = -1;
			}
			if(p_ptr->pclass != CLASS_NAZRIN && p_ptr->pclass != CLASS_KEINE ) //iY[͋mgȂ
			{

			strcpy(power_desc[num].name, "m");
			power_desc[num].level = 25;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = (cp_ptr->magicmaster ? 20:10);
			power_desc[num].info = "ꎞIɋmB";
			power_desc[num++].number = -2;
			}
			break;
		case RACE_GYOKUTO:

#ifdef JP
strcpy(power_desc[num].name, "\𕷂");
#endif
			power_desc[num].level = 1;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 0;
			power_desc[num].info = "ʓẽlbg[N\𕷂B";
			power_desc[num++].number = -1;

#ifdef JP
strcpy(power_desc[num].name, "X^[m");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 4;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num].info = "a(x/2+10)܂ł̃X^[̋Cz@mB";
			power_desc[num++].number = -2;

#ifdef JP
strcpy(power_desc[num].name, "V[gEe|[g");
#else
			strcpy(power_desc[num].name, "Probing");
#endif

			power_desc[num].level = 10;
			power_desc[num].cost = 8;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num].info = "Z̃e|[gB";
			power_desc[num++].number = -3;
			break;
		case RACE_YAMAWARO:

#ifdef JP
strcpy(power_desc[num].name, "ʔw");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 12;
			power_desc[num].info = "ꂽƂɂ郂X^[UBɉčU񐔂B";
			power_desc[num++].number = -1;
			break;

		case RACE_BAKEDANUKI:
			strcpy(power_desc[num].name, "X^[m");
			power_desc[num].level = 5;
			power_desc[num].cost = 4;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num].info = "a(x/2+10)܂ł̃X^[̋Cz@mB";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "e|[g");
			power_desc[num].level = 12;
			power_desc[num].cost = 14;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 24;
			power_desc[num].info = "̃e|[gB";
			power_desc[num++].number = -2;

			sprintf(power_desc[num].name, "ςg");
			power_desc[num].level = 30;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 50;
			power_desc[num].info = "U󂯂_[W󂯂Ƀe|[g悤ɂȂBs邱ƂB";
			power_desc[num++].number = -3;
			break;


		case RACE_YOUKO:
#ifdef JP
strcpy(power_desc[num].name, "X^[m");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 4;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num].info = "a(x/2+10)܂ł̃X^[̋Cz@mB";
			power_desc[num++].number = -1;
#ifdef JP
sprintf(power_desc[num].name, "_U (_[W %d)", lvl*2);
#else
			sprintf(power_desc[num].name, "Mind Blast (dam %d)", lvl);
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 14;
			power_desc[num].info = "^[Qbgɑ΂Ax*2̃_[W̐_UsB";
			power_desc[num++].number = -2;
#ifdef JP
strcpy(power_desc[num].name, "f");
#else
			strcpy(power_desc[num].name, "Dazzle");
#endif

			power_desc[num].level =25;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 20;
			power_desc[num].info = "ẼX^[NOAA|B";
			power_desc[num++].number = -3;
			break;
	case RACE_HOFGOBLIN:

#ifdef JP
strcpy(power_desc[num].name, "HƐ");
#endif
			power_desc[num].level = 5;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 10;
			power_desc[num].info = "͂̐ĤׂTČgѐHɎdグB";
			power_desc[num++].number = -1;
			break;
		case RACE_NYUDOU:
#ifdef JP
strcpy(power_desc[num].name, "V[gEe|[g");
#else
			strcpy(power_desc[num].name, "Probing");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 14;
			power_desc[num].info = "Z̃e|[gB";
			power_desc[num++].number = -1;

#ifdef JP
strcpy(power_desc[num].name, "e|[gEobN");
#else
			strcpy(power_desc[num].name, "Probing");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 20;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 25;
			power_desc[num].info = "ꂽꏊɂG̋߂ֈ񂹂B";
			power_desc[num++].number = -2;
			break;

		case RACE_STRAYGOD:
			deity_racial_power(power_desc, &num);

			break;
		case RACE_FAIRY:
			fairy_racial_power(power_desc, &num);
			break;

		case RACE_NINJA:
#ifdef JP
strcpy(power_desc[num].name, "XP");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 10;
			power_desc[num].info = "^[Qbg֖̃{g𕡐Bh͂̍ɂ͓ȂƂBx㏸ƐB";
			power_desc[num++].number = -1;

#ifdef JP
strcpy(power_desc[num].name, "`h[̌ċz");
#endif

			power_desc[num].level = 35;
			power_desc[num].cost = 1;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 60;
			power_desc[num].info = "Ȍċz@ŃjW񕜗͂B";
			power_desc[num++].number = -2;

			break;
		case RACE_GOLEM:
#ifdef JP
strcpy(power_desc[num].name, "ǐH");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 20;
			power_desc[num].info = "_W̕ǂHׂĉh{ɂB";
			power_desc[num++].number = -1;
			break;
		case RACE_LICH:
#ifdef JP
strcpy(power_desc[num].name, "GiW[hC");
#endif

			power_desc[num].level = 30;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 10;
			power_desc[num].info = "GɐGHPMPDB邱ƂBȂGɂ͖B";
			power_desc[num++].number = -1;

#ifdef JP
strcpy(power_desc[num].name, "n̔g");
#endif
			power_desc[num].level = 40;
			power_desc[num].cost = 43;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 20;
			power_desc[num].info = "E̐Ƀ_[W^AAfbhꑮB";
			power_desc[num++].number = -2;
			break;

		case RACE_LUNARIAN:

			strcpy(power_desc[num].name, "A");
			power_desc[num].level = 5;
			power_desc[num].cost = 20;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 10;
			power_desc[num].info = "nƃ_WsB";
			power_desc[num++].number = -1;

			strcpy(power_desc[num].name, "z");
			power_desc[num].level = 25;
			power_desc[num].cost = 32;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 40;
			power_desc[num].info = "z̋ʓeqĂяoB";
			power_desc[num++].number = -2;
			break;
		/*
		case RACE_DWARF:
#ifdef JP
strcpy(power_desc[num].name, "hA m");
#else
			strcpy(power_desc[num].name, "Detect Doors+Traps");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 12;
			power_desc[num++].number = -1;
			break;
		*/
		/*
		case RACE_NIBELUNG:
#ifdef JP
strcpy(power_desc[num].name, "hA m");
#else
			strcpy(power_desc[num].name, "Detect Doors+Traps");
#endif

			power_desc[num].level = 10;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 10;
			power_desc[num++].number = -1;
			break;
			*/
			/*
		case RACE_HOBBIT:
#ifdef JP
strcpy(power_desc[num].name, "HƐ");
#else
			strcpy(power_desc[num].name, "Create Food");
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 10;
			power_desc[num++].number = -1;
			break;
*/
/*
			case RACE_GNOME:
#ifdef JP
sprintf(power_desc[num].name, "V[gEe|[g");
#else
			sprintf(power_desc[num].name, "Blink");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num++].number = -1;
			break;
*/
			/*
			case RACE_HALF_ORC:
#ifdef JP
strcpy(power_desc[num].name, "|");
#else
			strcpy(power_desc[num].name, "Remove Fear");
#endif

			power_desc[num].level = 3;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = warrior ? 5 : 10;
			power_desc[num++].number = -1;
			break;
			*/
			/*
		case RACE_HALF_TROLL:
#ifdef JP
strcpy(power_desc[num].name, "m");
#else
			strcpy(power_desc[num].name, "Berserk");
#endif

			power_desc[num].level = 10;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = warrior ? 6 : 12;
			power_desc[num++].number = -1;
			break;
			*/
			/*
		case RACE_BARBARIAN:
#ifdef JP
strcpy(power_desc[num].name, "m");
#else
			strcpy(power_desc[num].name, "Berserk");
#endif

			power_desc[num].level = 8;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = warrior ? 6 : 12;
			power_desc[num++].number = -1;
			break;
			*/
			/*
		case RACE_AMBERITE:
#ifdef JP
strcpy(power_desc[num].name, "VhEEVtg");
#else
			strcpy(power_desc[num].name, "Shadow Shifting");
#endif

			power_desc[num].level = 30;
			power_desc[num].cost = 50;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 50;
			power_desc[num++].number = -1;
#ifdef JP
strcpy(power_desc[num].name, "p^[EEH[N");
#else
			strcpy(power_desc[num].name, "Pattern Mindwalking");
#endif

			power_desc[num].level = 40;
			power_desc[num].cost = 75;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 50;
			power_desc[num++].number = -2;
			break;
			*/
/*
		case RACE_HALF_OGRE:
#ifdef JP
strcpy(power_desc[num].name, "̃[");
#else
			strcpy(power_desc[num].name, "Explosive Rune");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 35;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 15;
			power_desc[num++].number = -1;
			break;
		case RACE_HALF_GIANT:
#ifdef JP
strcpy(power_desc[num].name, "Ηn");
#else
			strcpy(power_desc[num].name, "Stone to Mud");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 12;
			power_desc[num++].number = -1;
			break;
*/
/*
			case RACE_HALF_TITAN:
#ifdef JP
strcpy(power_desc[num].name, "XLEX^[");
#else
			strcpy(power_desc[num].name, "Probing");
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 10;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num++].number = -1;
			break;
		case RACE_CYCLOPS:
#ifdef JP
sprintf(power_desc[num].name, "Γi_[W %dj", (3 * lvl) / 2);
#else
			sprintf(power_desc[num].name, "Throw Boulder (dam %d)", (3 * lvl) / 2);
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 12;
			power_desc[num++].number = -1;
			break;
			*/
/*
			case RACE_YEEK:
#ifdef JP
strcpy(power_desc[num].name, "X^[Q");
#else
			strcpy(power_desc[num].name, "Scare Monster");
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 10;
			power_desc[num++].number = -1;
			break;
*/
/*
		case RACE_SPECTRE:
#ifdef JP
strcpy(power_desc[num].name, "X^[Q");
#else
			strcpy(power_desc[num].name, "Scare Monster");
#endif

			power_desc[num].level = 4;
			power_desc[num].cost = 6;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 3;
			power_desc[num++].number = -1;
			break;
		case RACE_KLACKON:
#ifdef JP
sprintf(power_desc[num].name, "_̑ (_[W %d)", lvl);
#else
			sprintf(power_desc[num].name, "Spit Acid (dam %d)", lvl);
#endif

			power_desc[num].level = 9;
			power_desc[num].cost = 9;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 14;
			power_desc[num++].number = -1;
			break;
		case RACE_KOBOLD:
#ifdef JP
sprintf(power_desc[num].name, "ł̃_[c (_[W %d)", lvl);
#else
			sprintf(power_desc[num].name, "Poison Dart (dam %d)", lvl);
#endif

			power_desc[num].level = 12;
			power_desc[num].cost = 8;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 14;
			power_desc[num++].number = -1;
			break;
		case RACE_DARK_ELF:
#ifdef JP
sprintf(power_desc[num].name, "}WbNE~TC (_[W %dd%d)", 3 + ((lvl - 1) / 5), 4);
#else
			sprintf(power_desc[num].name, "Magic Missile (dm %dd%d)", 3 + ((lvl - 1) / 5), 4);
#endif

			power_desc[num].level = 2;
			power_desc[num].cost = 2;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 9;
			power_desc[num++].number = -1;
			break;
*/
/*
			case RACE_DRACONIAN:
#ifdef JP
sprintf(power_desc[num].name, "uX (_[W %d)", lvl * 2);
#else
			sprintf(power_desc[num].name, "Breath Weapon (dam %d)", lvl * 2);
#endif

			power_desc[num].level = 1;
			power_desc[num].cost = lvl;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 12;
			power_desc[num++].number = -1;
			break;
		case RACE_MIND_FLAYER:
#ifdef JP
sprintf(power_desc[num].name, "_U (_[W %d)", lvl);
#else
			sprintf(power_desc[num].name, "Mind Blast (dam %d)", lvl);
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 14;
			power_desc[num++].number = -1;
			break;
		case RACE_IMP:
#ifdef JP
sprintf(power_desc[num].name, "t@CAE{g/{[ (_[W %d)", lvl);
#else
			sprintf(power_desc[num].name, "Fire Bolt/Ball (dam %d)", lvl);
#endif

			power_desc[num].level = 9;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 15;
			power_desc[num++].number = -1;
			break;
		case RACE_GOLEM:
#ifdef JP
strcpy(power_desc[num].name, "Ή ( 1d20+30)");
#else
			strcpy(power_desc[num].name, "Stone Skin (dur 1d20+30)");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 8;
			power_desc[num++].number = -1;
			break;
		*/
/*
		case RACE_SKELETON:
		case RACE_ZOMBIE:
#ifdef JP
strcpy(power_desc[num].name, "ol");
#else
			strcpy(power_desc[num].name, "Restore Life");
#endif

			power_desc[num].level = 30;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 18;
			power_desc[num++].number = -1;
			break;
*/
			case RACE_VAMPIRE:
#ifdef JP
strcpy(power_desc[num].name, "͋z");
#else
			strcpy(power_desc[num].name, "Drain Life");
#endif

			power_desc[num].level = 1;
			power_desc[num].cost = 1 + (lvl / 3);
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 9;
			power_desc[num].info = "GɊݕtČzA󕠂𖞂B";
			power_desc[num++].number = -1;
			break;
			/*
		case RACE_SPRITE:
#ifdef JP
strcpy(power_desc[num].name, "蕲");
#else
			strcpy(power_desc[num].name, "Sleeping Dust");
#endif

			power_desc[num].level = 12;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 15;
			power_desc[num++].number = -1;
			break;
			*/
/*
		case RACE_DEMON:
#ifdef JP
sprintf(power_desc[num].name, "n/Ή̃uX (_[W %d)", lvl * 3);
#else
			sprintf(power_desc[num].name, "Nether or Fire Breath (dam %d)", lvl * 3);
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 10+lvl/3;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 20;
			power_desc[num++].number = -1;
			break;
			*/
			/*
		case RACE_KUTAR:
#ifdef JP
strcpy(power_desc[num].name, "ɐLт");
#else
			strcpy(power_desc[num].name, "Expand Horizontally (dur 30+1d20)");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 8;
			power_desc[num++].number = -1;
			break;
			*/
			/*
		case RACE_ANDROID:
			if (p_ptr->lev < 10)
			{
#ifdef JP
strcpy(power_desc[num].name, "CK");
#else
				strcpy(power_desc[num].name, "Ray Gun");
#endif

				power_desc[num].level = 1;
				power_desc[num].cost = 7;
				power_desc[num].fail = 8;
			}
			else if (p_ptr->lev < 25)
			{
#ifdef JP
strcpy(power_desc[num].name, "uX^[");
#else
				strcpy(power_desc[num].name, "Blaster");
#endif

				power_desc[num].level = 10;
				power_desc[num].cost = 13;
				power_desc[num].fail = 10;
			}
			else if (p_ptr->lev < 35)
			{
#ifdef JP
strcpy(power_desc[num].name, "oY[J");
#else
				strcpy(power_desc[num].name, "Bazooka");
#endif

				power_desc[num].level = 25;
				power_desc[num].cost = 26;
				power_desc[num].fail = 12;
			}
			else if (p_ptr->lev < 45)
			{
#ifdef JP
strcpy(power_desc[num].name, "r[Lm");
#else
				strcpy(power_desc[num].name, "Beam Cannon");
#endif

				power_desc[num].level = 35;
				power_desc[num].cost = 40;
				power_desc[num].fail = 15;
			}
			else
			{
#ifdef JP
strcpy(power_desc[num].name, "Pbg");
#else
				strcpy(power_desc[num].name, "Rocket");
#endif

				power_desc[num].level = 45;
				power_desc[num].cost = 60;
				power_desc[num].fail = 18;
			}
			power_desc[num].stat = A_STR;
			power_desc[num++].number = -1;
			break;
			*/
		default:
		{
			break;
		}
	}
	}
	///mutation ˑRψقɂ郌CV
	if (p_ptr->muta1)
	{
		if (p_ptr->muta1 & MUT1_BR_ACID)
		{
#ifdef JP
strcpy(power_desc[num].name, "_̃uX");
#else
			strcpy(power_desc[num].name, "Spit Acid");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = (lvl+1)/2;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 18;
			power_desc[num].info = "_̃uXfB";
			power_desc[num++].number = MUT1_BR_ACID;
		}

		if (p_ptr->muta1 & MUT1_BR_FIRE)
		{
#ifdef JP
strcpy(power_desc[num].name, "̃uX");
#else
			strcpy(power_desc[num].name, "Fire Breath");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = (lvl + 1) / 2;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 18;
			power_desc[num].info = "Ή̃uXfB";
			power_desc[num++].number = MUT1_BR_FIRE;
		}

		if (p_ptr->muta1 & MUT1_HYPN_GAZE)
		{
#ifdef JP
strcpy(power_desc[num].name, "");
#else
			strcpy(power_desc[num].name, "Hypnotic Gaze");
#endif

			power_desc[num].level = 12;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 18;
			power_desc[num].info = "Ĝ𖣗AzɂB";
			power_desc[num++].number = MUT1_HYPN_GAZE;
		}

		if (p_ptr->muta1 & MUT1_TELEKINES)
		{
#ifdef JP
strcpy(power_desc[num].name, "O");
#else
			strcpy(power_desc[num].name, "Telekinesis");
#endif

			power_desc[num].level = 9;
			power_desc[num].cost = 9;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 14;
			power_desc[num].info = "ꂽƂɂACe𑫌Ɉ񂹂BACȅdʂ(x*0.5)Kg܂ŁB";
			power_desc[num++].number = MUT1_TELEKINES;
		}

		if (p_ptr->muta1 & MUT1_VTELEPORT)
		{
#ifdef JP
strcpy(power_desc[num].name, "e|[g");
#else
			strcpy(power_desc[num].name, "Teleport");
#endif

			power_desc[num].level = 7;
			power_desc[num].cost = 7;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 15;
			power_desc[num].info = "(x*4+10)̃e|[gB";
			power_desc[num++].number = MUT1_VTELEPORT;
		}

		if (p_ptr->muta1 & MUT1_MIND_BLST)
		{
#ifdef JP
strcpy(power_desc[num].name, "_U");
#else
			strcpy(power_desc[num].name, "Mind Blast");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 3;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 15;
			power_desc[num].info = "Ĝɑ΂_Ũ{gB";
			power_desc[num++].number = MUT1_MIND_BLST;
		}

		if (p_ptr->muta1 & MUT1_BR_ELEC)
		{
#ifdef JP
strcpy(power_desc[num].name, "̃uX");
#else
			strcpy(power_desc[num].name, "Emit Radiation");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = (lvl + 1) / 2;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 18;
			power_desc[num].info = "̃uXfB";
			power_desc[num++].number = MUT1_BR_ELEC;
		}

		if (p_ptr->muta1 & MUT1_VAMPIRISM)
		{
#ifdef JP
strcpy(power_desc[num].name, "z̉");
#else
			strcpy(power_desc[num].name, "Vampiric Drain");
#endif

			power_desc[num].level = 2;
			power_desc[num].cost = (1 + (lvl / 3));
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 9;
			power_desc[num].info = "GɊݕtČzA̗͂zĖx񕜂B";
			power_desc[num++].number = MUT1_VAMPIRISM;
		}

		if (p_ptr->muta1 & MUT1_ACCELERATION)
		{
#ifdef JP
strcpy(power_desc[num].name, "");
#else
			strcpy(power_desc[num].name, "Smell Metal");
#endif
			power_desc[num].level = 30;
			power_desc[num].cost = 30;
			power_desc[num].fail = 25;
			power_desc[num].stat = A_DEX;
			power_desc[num].info = "ꎞIɉB";
			power_desc[num++].number = MUT1_ACCELERATION;
		}

		if (p_ptr->muta1 & MUT1_BEAST_EAR)
		{
#ifdef JP
strcpy(power_desc[num].name, "X^[m");
#else
			strcpy(power_desc[num].name, "Smell Monsters");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 4;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 10;
			power_desc[num].info = "a(x/2+10)܂ł̃X^[̋Cz@mB";
			power_desc[num++].number = MUT1_BEAST_EAR;
		}

		if (p_ptr->muta1 & MUT1_BLINK)
		{
#ifdef JP
strcpy(power_desc[num].name, "V[gEe|[g");
#else
			strcpy(power_desc[num].name, "Blink");
#endif

			power_desc[num].level = 3;
			power_desc[num].cost = 3;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 12;
			power_desc[num].info = "10̃e|[gB";
			power_desc[num++].number = MUT1_BLINK;
		}

		if (p_ptr->muta1 & MUT1_EAT_ROCK)
		{
#ifdef JP
strcpy(power_desc[num].name, "H");
#else
			strcpy(power_desc[num].name, "Eat Rock");
#endif

			power_desc[num].level = 8;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 18;
			power_desc[num].info = "ǂHׂċ󕠂𖞂B";
			power_desc[num++].number = MUT1_EAT_ROCK;
		}

		if (p_ptr->muta1 & MUT1_SWAP_POS)
		{
#ifdef JP
strcpy(power_desc[num].name, "ʒu");
#else
			strcpy(power_desc[num].name, "Swap Position");
#endif

			power_desc[num].level = 15;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 16;
			power_desc[num].info = "w^[QbgƈʒuB";
			power_desc[num++].number = MUT1_SWAP_POS;
		}

		if (p_ptr->muta1 & MUT1_BR_SOUND)
		{
#ifdef JP
strcpy(power_desc[num].name, "U");
#else
			strcpy(power_desc[num].name, "Shriek");
#endif

			power_desc[num].level = 23;
			power_desc[num].cost = (lvl + 1) / 2;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 18;
			power_desc[num].info = "剹A͂̓GɍUB";
			power_desc[num++].number = MUT1_BR_SOUND;
		}

		if (p_ptr->muta1 & MUT1_BR_COLD)
		{
#ifdef JP
strcpy(power_desc[num].name, "C̃uX");
#else
			strcpy(power_desc[num].name, "Illuminate");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = (lvl + 1) / 2;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 18;
			power_desc[num].info = "C̃uXfB";
			power_desc[num++].number = MUT1_BR_COLD;
		}

		if (p_ptr->muta1 & MUT1_DET_ITEM)
		{
#ifdef JP
strcpy(power_desc[num].name, "ACem");
#else
			strcpy(power_desc[num].name, "Detect Curses");
#endif

			power_desc[num].level = 5;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 15;
			power_desc[num].info = "߂ɗĂACeT肾B";
			power_desc[num++].number = MUT1_DET_ITEM;
		}

		if (p_ptr->muta1 & MUT1_BERSERK)
		{
#ifdef JP
strcpy(power_desc[num].name, "m");
#else
			strcpy(power_desc[num].name, "Berserk");
#endif

			power_desc[num].level = 8;
			power_desc[num].cost = 8;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 14;
			power_desc[num].info = "ĂыNAꎞIɋmB";
			power_desc[num++].number = MUT1_BERSERK;
		}

		if (p_ptr->muta1 & MUT1_BR_POIS)
		{
#ifdef JP
strcpy(power_desc[num].name, "KX̃uX");
#else
			strcpy(power_desc[num].name, "Polymorph");
#endif

			power_desc[num].level = 20;
			power_desc[num].cost = (lvl + 1) / 2;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 18;
			power_desc[num].info = "ł̃uXfB";
			power_desc[num++].number = MUT1_BR_POIS;
		}

		if (p_ptr->muta1 & MUT1_MIDAS_TCH)
		{
#ifdef JP
strcpy(power_desc[num].name, "~_X̎");
#else
			strcpy(power_desc[num].name, "Midas Touch");
#endif

			power_desc[num].level = 10;
			power_desc[num].cost = 5;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 12;
			power_desc[num].info = "w肵ACeGċɕςBz̓ACẻl1/3ƂȂB";
			power_desc[num++].number = MUT1_MIDAS_TCH;
		}

		if (p_ptr->muta1 & MUT1_GROW_MOLD)
		{
#ifdef JP
strcpy(power_desc[num].name, "Jr");
#else
			strcpy(power_desc[num].name, "Grow Mold");
#endif

			power_desc[num].level = 1;
			power_desc[num].cost = 6;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 14;
			power_desc[num].info = "̎͂ɃJr̃X^[B";
			power_desc[num++].number = MUT1_GROW_MOLD;
		}

		if (p_ptr->muta1 & MUT1_RESIST)
		{
#ifdef JP
strcpy(power_desc[num].name, "Ggϐ");
#else
			strcpy(power_desc[num].name, "Resist Elements");
#endif

			power_desc[num].level = 10;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_CON;
			power_desc[num].fail = 12;
			power_desc[num].info = "ꎞIɎ_AdAΉACAł̂̑ϐ𓾂B";
			power_desc[num++].number = MUT1_RESIST;
		}

		if (p_ptr->muta1 & MUT1_EARTHQUAKE)
		{
#ifdef JP
strcpy(power_desc[num].name, "nk");
#else
			strcpy(power_desc[num].name, "Earthquake");
#endif

			power_desc[num].level = 12;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 16;
			power_desc[num].info = "nkNA_W̏ǂ_ɓւB";
			power_desc[num++].number = MUT1_EARTHQUAKE;
		}

		if (p_ptr->muta1 & MUT1_EAT_MAGIC)
		{
#ifdef JP
strcpy(power_desc[num].name, "͐H");
#else
			strcpy(power_desc[num].name, "Eat Magic");
#endif

			power_desc[num].level = 17;
			power_desc[num].cost = 1;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 15;
			power_desc[num].info = "̖͂zMP񕜂B邱ƂB";
			power_desc[num++].number = MUT1_EAT_MAGIC;
		}

		if (p_ptr->muta1 & MUT1_RAISE_WOOD)
		{
#ifdef JP
strcpy(power_desc[num].name, "ؐ");
#else
			strcpy(power_desc[num].name, "Weigh Magic");
#endif

			power_desc[num].level = 25;
			power_desc[num].cost = 30;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 20;
			power_desc[num].info = "̂ꏊXтɂB";
			power_desc[num++].number = MUT1_RAISE_WOOD;
		}

		if (p_ptr->muta1 & MUT1_STERILITY)
		{
#ifdef JP
strcpy(power_desc[num].name, "Bj~");
#else
			strcpy(power_desc[num].name, "Sterilize");
#endif

			power_desc[num].level = 12;
			power_desc[num].cost = 23;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 15;
			power_desc[num].info = "tȂB郂X^[ȏ㑝BłȂȂB";
			power_desc[num++].number = MUT1_STERILITY;
		}

		if (p_ptr->muta1 & MUT1_PANIC_HIT)
		{
#ifdef JP
strcpy(power_desc[num].name, "qbgAEFC");
#else
			strcpy(power_desc[num].name, "Panic Hit");
#endif

			power_desc[num].level = 10;
			power_desc[num].cost = 12;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 14;
			power_desc[num].info = "Ud|Ǎuł̏ꂩ痣EBs邱ƂB";
			power_desc[num++].number = MUT1_PANIC_HIT;
		}

		if (p_ptr->muta1 & MUT1_DAZZLE)
		{
#ifdef JP
strcpy(power_desc[num].name, "C̖");
#else
			strcpy(power_desc[num].name, "Dazzle");
#endif

			power_desc[num].level = 7;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 8;
			power_desc[num].info = "ẼX^[𖰂点AA|B";
			power_desc[num++].number = MUT1_DAZZLE;
		}

		if (p_ptr->muta1 & MUT1_LASER_EYE)
		{
#ifdef JP
strcpy(power_desc[num].name, "ڂr[");
#else
			strcpy(power_desc[num].name, "Laser Eye");
#endif

			power_desc[num].level = 10;
			power_desc[num].cost = 15;
			power_desc[num].stat = A_WIS;
			power_desc[num].fail = 15;
			power_desc[num].info = "M̃r[B";
			power_desc[num++].number = MUT1_LASER_EYE;
		}

		if (p_ptr->muta1 & MUT1_RECALL)
		{
#ifdef JP
strcpy(power_desc[num].name, "A");
#else
			strcpy(power_desc[num].name, "Recall");
#endif

			power_desc[num].level = 17;
			power_desc[num].cost = 50;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 16;
			power_desc[num].info = "nƃ_WsBʂ̔܂łɃ^COB";
			power_desc[num++].number = MUT1_RECALL;
		}

		if (p_ptr->muta1 & MUT1_ID_MUSHROOM)
		{
#ifdef JP
strcpy(power_desc[num].name, "LmRӒ");
#else
			strcpy(power_desc[num].name, "Banish Evil");
#endif

			power_desc[num].level = 3;
			power_desc[num].cost = 3;
			power_desc[num].stat = A_INT;
			power_desc[num].fail = 8;
			power_desc[num].info = "ĂLmRSĊӒ肷B";
			power_desc[num++].number = MUT1_ID_MUSHROOM;
		}
		//v1.1.39
		if (p_ptr->muta1 & MUT1_DANMAKU)
		{
			strcpy(power_desc[num].name, "G߂̗");

			power_desc[num].level = 10;
			power_desc[num].cost = 40;
			power_desc[num].stat = A_CHR;
			power_desc[num].fail = 25;
			power_desc[num].info = "(*5)̈З͂̋ȃ{[B";
			power_desc[num++].number = MUT1_DANMAKU;
		}

#if 0
		if (p_ptr->muta1 & MUT1_LAUNCHER)
		{
#ifdef JP
strcpy(power_desc[num].name, "ACe");
#else
			strcpy(power_desc[num].name, "Throw Object");
#endif

			power_desc[num].level = 1;
			power_desc[num].cost = lvl;
			power_desc[num].stat = A_STR;
			power_desc[num].fail = 6;
			/* XXX_XXX_XXX Hack! MUT1_LAUNCHER counts as negative... */
			power_desc[num++].number = 3;
		}
#endif
	}
	if(p_ptr->clawextend)
	{
			strcpy(power_desc[num].name, "n܎E@");
			power_desc[num].level = 20;
			power_desc[num].cost = 25;
			power_desc[num].stat = A_DEX;
			power_desc[num].fail = 15;
			power_desc[num].info = "אڂGSĂɍUBőϐ̂ȂGɑ΂č_[W^B";
			power_desc[num++].number = -100;
	}


	/* Nothing chosen yet */
	flag = FALSE;

	/* No redraw yet */
	redraw = FALSE;

	/* Build a prompt */
#ifdef JP

	if(!num)
	{
		msg_print("Ȃ͈ӎĎg悤ȓ\͂ĂȂB");
		return;
	}
if(only_info)
	(void) strnfmt(out_val, 78, "(\ %c-%c, *'ňꗗ, ESCŒf) ǂ̓\͂̐܂H",	I2A(0), (num <= 26) ? I2A(num - 1) : '0' + num - 27);
else
	(void) strnfmt(out_val, 78, "(\ %c-%c, *'ňꗗ, ESCŒf) ǂ̓\͂g܂H",	I2A(0), (num <= 26) ? I2A(num - 1) : '0' + num - 27);

#else
	(void)strnfmt(out_val, 78, "(Powers %c-%c, *=List, ESC=exit) Use which power? ",
		I2A(0), (num <= 26) ? I2A(num - 1) : '0' + num - 27);
#endif


#ifdef ALLOW_REPEAT
if (!repeat_pull(&i) || i<0 || i>=num) {
#endif /* ALLOW_REPEAT */
	if (use_menu) screen_save();
	 /* Get a spell from the user */

	choice = (always_show_list || use_menu) ? ESCAPE:1;
	while (!flag)
	{
		if( choice==ESCAPE ) choice = ' '; 
		else if( !get_com(out_val, &choice, FALSE) )break; 

		if (use_menu && choice != ' ')
		{
			switch(choice)
			{
				case '0':
				{
					screen_load();
					energy_use = 0;
					return;
				}

				case '8':
				case 'k':
				case 'K':
				{
					menu_line += (num - 1);
					break;
				}

				case '2':
				case 'j':
				case 'J':
				{
					menu_line++;
					break;
				}

				case '6':
				case 'l':
				case 'L':
				case '4':
				case 'h':
				case 'H':
				{
					if (menu_line > 18)
						menu_line -= 18;
					else if (menu_line+18 <= num)
						menu_line += 18;
					break;
				}

				case 'x':
				case 'X':
				case '\r':
				{
					i = menu_line - 1;
					ask = FALSE;
					break;
				}
			}
			if (menu_line > num) menu_line -= num;
		}
		/* Request redraw */
		if ((choice == ' ') || (choice == '*') || (choice == '?') || (use_menu && ask))
		{
			/* Show the list */
			if (!redraw || use_menu)
			{
				byte y = 1, x = 0;
				int ctr = 0;
				char dummy[80];
				char letter;
				int x1, y1;

				strcpy(dummy, "");

				/* Show list */
				redraw = TRUE;

				/* Save the screen */
				if (!use_menu) screen_save();

				/* Print header(s) */
				if (num < 18)
#ifdef JP
prt("                            Lv   MP ", y++, x);
#else
					prt("                            Lv Cost Fail", y++, x);
#endif

				else
#ifdef JP
prt("                            Lv   MP                             Lv   MP ", y++, x);
#else
					prt("                            Lv Cost Fail                            Lv Cost Fail", y++, x);
#endif


				/* Print list */
				while (ctr < num)
				{
					x1 = ((ctr < 18) ? x : x + 40);
					y1 = ((ctr < 18) ? y + ctr : y + ctr - 18);

					if (use_menu)
					{
#ifdef JP
						if (ctr == (menu_line-1)) strcpy(dummy, " t ");
#else
						if (ctr == (menu_line-1)) strcpy(dummy, " >  ");
#endif
						else strcpy(dummy, "    ");
					}
					else
					{
						/* letter/number for power selection */
						if (ctr < 26)
							letter = I2A(ctr);
						else
							letter = '0' + ctr - 26;
						sprintf(dummy, " %c) ",letter);
					}
					strcat(dummy, format("%-23.23s %2d %4d %3d%%",
						power_desc[ctr].name, power_desc[ctr].level, power_desc[ctr].cost,
						100 - racial_chance(&power_desc[ctr])));
					prt(dummy, y1, x1);
					ctr++;
				}
			}

			/* Hide the list */
			else
			{
				/* Hide list */
				redraw = FALSE;

				/* Restore the screen */
				screen_load();
			}

			/* Redo asking */
			continue;
		}

		if (!use_menu)
		{
			if (choice == '\r' && num == 1)
			{
				choice = 'a';
			}

			if (isalpha(choice))
			{
				/* Note verify */
				ask = (isupper(choice));

				/* Lowercase */
				if (ask) choice = tolower(choice);

				/* Extract request */
				i = (islower(choice) ? A2I(choice) : -1);
			}
			else
			{
				ask = FALSE; /* Can't uppercase digits */

				i = choice - '0' + 26;
			}
		}

		/* Totally Illegal */
		if ((i < 0) || (i >= num))
		{
			bell();
			continue;
		}

		/* Verify it */
		if (ask && !only_info)
		{
			char tmp_val[160];

			/* Prompt */
#ifdef JP
(void) strnfmt(tmp_val, 78, "%sg܂H ", power_desc[i].name);
#else
			(void)strnfmt(tmp_val, 78, "Use %s? ", power_desc[i].name);
#endif


			/* Belay that order */
			if (!get_check(tmp_val)) continue;
		}

		/* Stop the loop */
		flag = TRUE;
	}

	/* Restore the screen */
	if (redraw) screen_load();

	/* Abort if needed */
	if (!flag)
	{
		energy_use = 0;
		return;
	}
#ifdef ALLOW_REPEAT
	if(!only_info) repeat_push(i);
	} /*if (!repeat_pull(&i) || ...)*/
#endif /* ALLOW_REPEAT */

	if(only_info)
	{
		int j, line;
		char temp[62*5];
		screen_save();
		Term_erase(12, 21, 255);
		Term_erase(12, 20, 255);
		Term_erase(12, 19, 255);
		Term_erase(12, 18, 255);
		Term_erase(12, 17, 255);
		Term_erase(12, 16, 255);
		roff_to_buf(power_desc[i].info, 62, temp, sizeof(temp));
		for(j=0, line = 17;temp[j];j+=(1+strlen(&temp[j])))
		{
			prt(&temp[j], line, 15);
			line++;
		}
		prt("L[ĉB",0,0);
		(void)inkey();
		screen_load();


		energy_use = 0;
		return;
	}



	/*:::*/
	switch (racial_aux(&power_desc[i]))
	{
	case 1:
		if (power_desc[i].number < 0)
			cast = cmd_racial_power_aux(power_desc[i].number);
		else
			cast = mutation_power_aux(power_desc[i].number);
		break;
	case 0:
		cast = FALSE;
		break;
	case -1:
		cast = TRUE;
		break;
	}

	if (cast)
	{
		if (racial_cost)
		{
			int actual_racial_cost = racial_cost / 2 + randint1(racial_cost / 2);

			/* If mana is not enough, player consumes hit point! */
			if (p_ptr->csp < actual_racial_cost)
			{
				actual_racial_cost -= p_ptr->csp;
				p_ptr->csp = 0;
#ifdef JP
				take_hit(DAMAGE_USELIFE, actual_racial_cost, "ߓx̏W", -1);
#else
				take_hit(DAMAGE_USELIFE, actual_racial_cost, "concentrating too hard", -1);
#endif
			}
			else p_ptr->csp -= actual_racial_cost;

			/* Redraw mana and hp */
			p_ptr->redraw |= (PR_HP | PR_MANA);

			/* Window stuff */
			p_ptr->window |= (PW_PLAYER | PW_SPELL);
		}
	}
	else energy_use = 0;

	/* Success */
	return;
}
